import { BaseUnit, ToStringOptions } from "../base-unit";
/** API DTO represents a ElectricPotentialChangeRate */
export interface ElectricPotentialChangeRateDto {
    /** The value of the ElectricPotentialChangeRate */
    value: number;
    /**  The specific unit that the ElectricPotentialChangeRate value is representing */
    unit: ElectricPotentialChangeRateUnits;
}
/** ElectricPotentialChangeRateUnits enumeration */
export declare enum ElectricPotentialChangeRateUnits {
    /** */
    VoltsPerSeconds = "VoltPerSecond",
    /** */
    VoltsPerMicroseconds = "VoltPerMicrosecond",
    /** */
    VoltsPerMinutes = "VoltPerMinute",
    /** */
    VoltsPerHours = "VoltPerHour",
    /** */
    MicrovoltsPerSeconds = "MicrovoltPerSecond",
    /** */
    MillivoltsPerSeconds = "MillivoltPerSecond",
    /** */
    KilovoltsPerSeconds = "KilovoltPerSecond",
    /** */
    MegavoltsPerSeconds = "MegavoltPerSecond",
    /** */
    MicrovoltsPerMicroseconds = "MicrovoltPerMicrosecond",
    /** */
    MillivoltsPerMicroseconds = "MillivoltPerMicrosecond",
    /** */
    KilovoltsPerMicroseconds = "KilovoltPerMicrosecond",
    /** */
    MegavoltsPerMicroseconds = "MegavoltPerMicrosecond",
    /** */
    MicrovoltsPerMinutes = "MicrovoltPerMinute",
    /** */
    MillivoltsPerMinutes = "MillivoltPerMinute",
    /** */
    KilovoltsPerMinutes = "KilovoltPerMinute",
    /** */
    MegavoltsPerMinutes = "MegavoltPerMinute",
    /** */
    MicrovoltsPerHours = "MicrovoltPerHour",
    /** */
    MillivoltsPerHours = "MillivoltPerHour",
    /** */
    KilovoltsPerHours = "KilovoltPerHour",
    /** */
    MegavoltsPerHours = "MegavoltPerHour"
}
/** ElectricPotential change rate is the ratio of the electric potential change to the time during which the change occurred (value of electric potential changes per unit time). */
export declare class ElectricPotentialChangeRate extends BaseUnit {
    protected value: number;
    private voltspersecondsLazy;
    private voltspermicrosecondsLazy;
    private voltsperminutesLazy;
    private voltsperhoursLazy;
    private microvoltspersecondsLazy;
    private millivoltspersecondsLazy;
    private kilovoltspersecondsLazy;
    private megavoltspersecondsLazy;
    private microvoltspermicrosecondsLazy;
    private millivoltspermicrosecondsLazy;
    private kilovoltspermicrosecondsLazy;
    private megavoltspermicrosecondsLazy;
    private microvoltsperminutesLazy;
    private millivoltsperminutesLazy;
    private kilovoltsperminutesLazy;
    private megavoltsperminutesLazy;
    private microvoltsperhoursLazy;
    private millivoltsperhoursLazy;
    private kilovoltsperhoursLazy;
    private megavoltsperhoursLazy;
    /**
     * Create a new ElectricPotentialChangeRate.
     * @param value The value.
     * @param fromUnit The ‘ElectricPotentialChangeRate’ unit to create from.
     * The default unit is VoltsPerSeconds
     */
    constructor(value: number, fromUnit?: ElectricPotentialChangeRateUnits);
    /**
     * The base value of ElectricPotentialChangeRate is VoltsPerSeconds.
     * This accessor used when needs a value for calculations and it's better to use directly the base value
     */
    get BaseValue(): number;
    /** Gets the default unit used when creating instances of the unit or its DTO */
    protected get baseUnit(): ElectricPotentialChangeRateUnits.VoltsPerSeconds;
    /** */
    get VoltsPerSeconds(): number;
    /** */
    get VoltsPerMicroseconds(): number;
    /** */
    get VoltsPerMinutes(): number;
    /** */
    get VoltsPerHours(): number;
    /** */
    get MicrovoltsPerSeconds(): number;
    /** */
    get MillivoltsPerSeconds(): number;
    /** */
    get KilovoltsPerSeconds(): number;
    /** */
    get MegavoltsPerSeconds(): number;
    /** */
    get MicrovoltsPerMicroseconds(): number;
    /** */
    get MillivoltsPerMicroseconds(): number;
    /** */
    get KilovoltsPerMicroseconds(): number;
    /** */
    get MegavoltsPerMicroseconds(): number;
    /** */
    get MicrovoltsPerMinutes(): number;
    /** */
    get MillivoltsPerMinutes(): number;
    /** */
    get KilovoltsPerMinutes(): number;
    /** */
    get MegavoltsPerMinutes(): number;
    /** */
    get MicrovoltsPerHours(): number;
    /** */
    get MillivoltsPerHours(): number;
    /** */
    get KilovoltsPerHours(): number;
    /** */
    get MegavoltsPerHours(): number;
    /**
     * Create a new ElectricPotentialChangeRate instance from a VoltsPerSeconds
     *
     * @param value The unit as VoltsPerSeconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromVoltsPerSeconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a VoltsPerMicroseconds
     *
     * @param value The unit as VoltsPerMicroseconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromVoltsPerMicroseconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a VoltsPerMinutes
     *
     * @param value The unit as VoltsPerMinutes to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromVoltsPerMinutes(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a VoltsPerHours
     *
     * @param value The unit as VoltsPerHours to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromVoltsPerHours(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MicrovoltsPerSeconds
     *
     * @param value The unit as MicrovoltsPerSeconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMicrovoltsPerSeconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MillivoltsPerSeconds
     *
     * @param value The unit as MillivoltsPerSeconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMillivoltsPerSeconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a KilovoltsPerSeconds
     *
     * @param value The unit as KilovoltsPerSeconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromKilovoltsPerSeconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MegavoltsPerSeconds
     *
     * @param value The unit as MegavoltsPerSeconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMegavoltsPerSeconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MicrovoltsPerMicroseconds
     *
     * @param value The unit as MicrovoltsPerMicroseconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMicrovoltsPerMicroseconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MillivoltsPerMicroseconds
     *
     * @param value The unit as MillivoltsPerMicroseconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMillivoltsPerMicroseconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a KilovoltsPerMicroseconds
     *
     * @param value The unit as KilovoltsPerMicroseconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromKilovoltsPerMicroseconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MegavoltsPerMicroseconds
     *
     * @param value The unit as MegavoltsPerMicroseconds to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMegavoltsPerMicroseconds(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MicrovoltsPerMinutes
     *
     * @param value The unit as MicrovoltsPerMinutes to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMicrovoltsPerMinutes(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MillivoltsPerMinutes
     *
     * @param value The unit as MillivoltsPerMinutes to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMillivoltsPerMinutes(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a KilovoltsPerMinutes
     *
     * @param value The unit as KilovoltsPerMinutes to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromKilovoltsPerMinutes(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MegavoltsPerMinutes
     *
     * @param value The unit as MegavoltsPerMinutes to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMegavoltsPerMinutes(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MicrovoltsPerHours
     *
     * @param value The unit as MicrovoltsPerHours to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMicrovoltsPerHours(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MillivoltsPerHours
     *
     * @param value The unit as MillivoltsPerHours to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMillivoltsPerHours(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a KilovoltsPerHours
     *
     * @param value The unit as KilovoltsPerHours to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromKilovoltsPerHours(value: number): ElectricPotentialChangeRate;
    /**
     * Create a new ElectricPotentialChangeRate instance from a MegavoltsPerHours
     *
     * @param value The unit as MegavoltsPerHours to create a new ElectricPotentialChangeRate from.
     * @returns The new ElectricPotentialChangeRate instance.
     */
    static FromMegavoltsPerHours(value: number): ElectricPotentialChangeRate;
    /**
     * Gets the base unit enumeration associated with ElectricPotentialChangeRate
     * @returns The unit enumeration that can be used to interact with this type
     */
    protected static getUnitEnum(): typeof ElectricPotentialChangeRateUnits;
    /**
     * Gets the default unit used when creating instances of the unit or its DTO
     * @returns The unit enumeration value used as a default parameter in constructor and DTO methods
     */
    protected static getBaseUnit(): ElectricPotentialChangeRateUnits.VoltsPerSeconds;
    /**
     * Create API DTO represent a ElectricPotentialChangeRate unit.
     * @param holdInUnit The specific ElectricPotentialChangeRate unit to be used in the unit representation at the DTO
     */
    toDto(holdInUnit?: ElectricPotentialChangeRateUnits): ElectricPotentialChangeRateDto;
    /**
     * Create a ElectricPotentialChangeRate unit from an API DTO representation.
     * @param dtoElectricPotentialChangeRate The ElectricPotentialChangeRate API DTO representation
     */
    static FromDto(dtoElectricPotentialChangeRate: ElectricPotentialChangeRateDto): ElectricPotentialChangeRate;
    /**
     * Convert ElectricPotentialChangeRate to a specific unit value.
     * @param toUnit The specific unit to convert to
     * @returns The value of the specific unit provided.
     */
    convert(toUnit: ElectricPotentialChangeRateUnits): number;
    private convertFromBase;
    private convertToBase;
    /**
     * Format the ElectricPotentialChangeRate to string.
     * Note! the default format for ElectricPotentialChangeRate is VoltsPerSeconds.
     * To specify the unit format set the 'unit' parameter.
     * @param unit The unit to format the ElectricPotentialChangeRate.
     * @param options The ToString options, it also can be the number of fractional digits to keep that deprecated and moved to the options object. support in number will be dropped in the upcoming versions.
     * @returns The string format of the ElectricPotentialChangeRate.
     */
    toString(unit?: ElectricPotentialChangeRateUnits, options?: number | ToStringOptions): string;
    /**
     * Get ElectricPotentialChangeRate unit abbreviation.
     * Note! the default abbreviation for ElectricPotentialChangeRate is VoltsPerSeconds.
     * To specify the unit abbreviation set the 'unitAbbreviation' parameter.
     * @param unitAbbreviation The unit abbreviation of the ElectricPotentialChangeRate.
     * @returns The abbreviation string of ElectricPotentialChangeRate.
     */
    getUnitAbbreviation(unitAbbreviation?: ElectricPotentialChangeRateUnits): string;
    /**
     * Check if the given ElectricPotentialChangeRate are equals to the current ElectricPotentialChangeRate.
     * @param electricPotentialChangeRate The other ElectricPotentialChangeRate.
     * @returns True if the given ElectricPotentialChangeRate are equal to the current ElectricPotentialChangeRate.
     */
    equals(electricPotentialChangeRate: ElectricPotentialChangeRate): boolean;
    /**
     * Compare the given ElectricPotentialChangeRate against the current ElectricPotentialChangeRate.
     * @param electricPotentialChangeRate The other ElectricPotentialChangeRate.
     * @returns 0 if they are equal, -1 if the current ElectricPotentialChangeRate is less then other, 1 if the current ElectricPotentialChangeRate is greater then other.
     */
    compareTo(electricPotentialChangeRate: ElectricPotentialChangeRate): number;
    /**
     * Add the given ElectricPotentialChangeRate with the current ElectricPotentialChangeRate.
     * @param electricPotentialChangeRate The other ElectricPotentialChangeRate.
     * @returns A new ElectricPotentialChangeRate instance with the results.
     */
    add(electricPotentialChangeRate: ElectricPotentialChangeRate): ElectricPotentialChangeRate;
    /**
     * Subtract the given ElectricPotentialChangeRate with the current ElectricPotentialChangeRate.
     * @param electricPotentialChangeRate The other ElectricPotentialChangeRate.
     * @returns A new ElectricPotentialChangeRate instance with the results.
     */
    subtract(electricPotentialChangeRate: ElectricPotentialChangeRate): ElectricPotentialChangeRate;
    /**
     * Multiply the given ElectricPotentialChangeRate with the current ElectricPotentialChangeRate.
     * @param electricPotentialChangeRate The other ElectricPotentialChangeRate.
     * @returns A new ElectricPotentialChangeRate instance with the results.
     */
    multiply(electricPotentialChangeRate: ElectricPotentialChangeRate): ElectricPotentialChangeRate;
    /**
     * Divide the given ElectricPotentialChangeRate with the current ElectricPotentialChangeRate.
     * @param electricPotentialChangeRate The other ElectricPotentialChangeRate.
     * @returns A new ElectricPotentialChangeRate instance with the results.
     */
    divide(electricPotentialChangeRate: ElectricPotentialChangeRate): ElectricPotentialChangeRate;
    /**
     * Modulo the given ElectricPotentialChangeRate with the current ElectricPotentialChangeRate.
     * @param electricPotentialChangeRate The other ElectricPotentialChangeRate.
     * @returns A new ElectricPotentialChangeRate instance with the results.
     */
    modulo(electricPotentialChangeRate: ElectricPotentialChangeRate): ElectricPotentialChangeRate;
    /**
     * Pow the given ElectricPotentialChangeRate with the current ElectricPotentialChangeRate.
     * @param electricPotentialChangeRate The other ElectricPotentialChangeRate.
     * @returns A new ElectricPotentialChangeRate instance with the results.
     */
    pow(electricPotentialChangeRate: ElectricPotentialChangeRate): ElectricPotentialChangeRate;
}
