"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FluidResistance = exports.FluidResistanceUnits = void 0;
const base_unit_1 = require("../base-unit");
/** FluidResistanceUnits enumeration */
var FluidResistanceUnits;
(function (FluidResistanceUnits) {
    /** */
    FluidResistanceUnits["PascalSecondsPerLiter"] = "PascalSecondPerLiter";
    /** */
    FluidResistanceUnits["PascalMinutesPerLiter"] = "PascalMinutePerLiter";
    /** */
    FluidResistanceUnits["PascalSecondsPerMilliliter"] = "PascalSecondPerMilliliter";
    /** */
    FluidResistanceUnits["PascalMinutesPerMilliliter"] = "PascalMinutePerMilliliter";
    /** */
    FluidResistanceUnits["PascalSecondsPerCubicMeter"] = "PascalSecondPerCubicMeter";
    /** */
    FluidResistanceUnits["PascalMinutesPerCubicMeter"] = "PascalMinutePerCubicMeter";
    /** */
    FluidResistanceUnits["PascalSecondsPerCubicCentimeter"] = "PascalSecondPerCubicCentimeter";
    /** */
    FluidResistanceUnits["PascalMinutesPerCubicCentimeter"] = "PascalMinutePerCubicCentimeter";
    /** */
    FluidResistanceUnits["DyneSecondsPerCentimeterToTheFifth"] = "DyneSecondPerCentimeterToTheFifth";
    /** */
    FluidResistanceUnits["MillimeterMercurySecondsPerLiter"] = "MillimeterMercurySecondPerLiter";
    /** */
    FluidResistanceUnits["MillimeterMercuryMinutesPerLiter"] = "MillimeterMercuryMinutePerLiter";
    /** */
    FluidResistanceUnits["MillimeterMercurySecondsPerMilliliter"] = "MillimeterMercurySecondPerMilliliter";
    /** */
    FluidResistanceUnits["MillimeterMercuryMinutesPerMilliliter"] = "MillimeterMercuryMinutePerMilliliter";
    /** */
    FluidResistanceUnits["MillimeterMercurySecondsPerCubicCentimeter"] = "MillimeterMercurySecondPerCubicCentimeter";
    /** */
    FluidResistanceUnits["MillimeterMercuryMinutesPerCubicCentimeter"] = "MillimeterMercuryMinutePerCubicCentimeter";
    /** */
    FluidResistanceUnits["MillimeterMercurySecondsPerCubicMeter"] = "MillimeterMercurySecondPerCubicMeter";
    /** */
    FluidResistanceUnits["MillimeterMercuryMinutesPerCubicMeter"] = "MillimeterMercuryMinutePerCubicMeter";
    /** */
    FluidResistanceUnits["WoodUnits"] = "WoodUnit";
    /** */
    FluidResistanceUnits["MegapascalSecondsPerCubicMeter"] = "MegapascalSecondPerCubicMeter";
})(FluidResistanceUnits = exports.FluidResistanceUnits || (exports.FluidResistanceUnits = {}));
/** Fluid Resistance is a force acting opposite to the relative motion of any object moving with respect to a surrounding fluid. Fluid Resistance is sometimes referred to as drag or fluid friction. */
class FluidResistance extends base_unit_1.BaseUnit {
    /**
     * Create a new FluidResistance.
     * @param value The value.
     * @param fromUnit The ‘FluidResistance’ unit to create from.
     * The default unit is PascalSecondsPerCubicMeter
     */
    constructor(value, fromUnit = FluidResistanceUnits.PascalSecondsPerCubicMeter) {
        super();
        this.pascalsecondsperliterLazy = null;
        this.pascalminutesperliterLazy = null;
        this.pascalsecondspermilliliterLazy = null;
        this.pascalminutespermilliliterLazy = null;
        this.pascalsecondspercubicmeterLazy = null;
        this.pascalminutespercubicmeterLazy = null;
        this.pascalsecondspercubiccentimeterLazy = null;
        this.pascalminutespercubiccentimeterLazy = null;
        this.dynesecondspercentimetertothefifthLazy = null;
        this.millimetermercurysecondsperliterLazy = null;
        this.millimetermercuryminutesperliterLazy = null;
        this.millimetermercurysecondspermilliliterLazy = null;
        this.millimetermercuryminutespermilliliterLazy = null;
        this.millimetermercurysecondspercubiccentimeterLazy = null;
        this.millimetermercuryminutespercubiccentimeterLazy = null;
        this.millimetermercurysecondspercubicmeterLazy = null;
        this.millimetermercuryminutespercubicmeterLazy = null;
        this.woodunitsLazy = null;
        this.megapascalsecondspercubicmeterLazy = null;
        if (value === undefined || value === null || Number.isNaN(value)) {
            throw new TypeError('invalid unit value ‘' + value + '’');
        }
        this.value = this.convertToBase(value, fromUnit);
    }
    /**
     * The base value of FluidResistance is PascalSecondsPerCubicMeter.
     * This accessor used when needs a value for calculations and it's better to use directly the base value
     */
    get BaseValue() {
        return this.value;
    }
    /** Gets the default unit used when creating instances of the unit or its DTO */
    get baseUnit() {
        return FluidResistanceUnits.PascalSecondsPerCubicMeter;
    }
    /** */
    get PascalSecondsPerLiter() {
        if (this.pascalsecondsperliterLazy !== null) {
            return this.pascalsecondsperliterLazy;
        }
        return this.pascalsecondsperliterLazy = this.convertFromBase(FluidResistanceUnits.PascalSecondsPerLiter);
    }
    /** */
    get PascalMinutesPerLiter() {
        if (this.pascalminutesperliterLazy !== null) {
            return this.pascalminutesperliterLazy;
        }
        return this.pascalminutesperliterLazy = this.convertFromBase(FluidResistanceUnits.PascalMinutesPerLiter);
    }
    /** */
    get PascalSecondsPerMilliliter() {
        if (this.pascalsecondspermilliliterLazy !== null) {
            return this.pascalsecondspermilliliterLazy;
        }
        return this.pascalsecondspermilliliterLazy = this.convertFromBase(FluidResistanceUnits.PascalSecondsPerMilliliter);
    }
    /** */
    get PascalMinutesPerMilliliter() {
        if (this.pascalminutespermilliliterLazy !== null) {
            return this.pascalminutespermilliliterLazy;
        }
        return this.pascalminutespermilliliterLazy = this.convertFromBase(FluidResistanceUnits.PascalMinutesPerMilliliter);
    }
    /** */
    get PascalSecondsPerCubicMeter() {
        if (this.pascalsecondspercubicmeterLazy !== null) {
            return this.pascalsecondspercubicmeterLazy;
        }
        return this.pascalsecondspercubicmeterLazy = this.convertFromBase(FluidResistanceUnits.PascalSecondsPerCubicMeter);
    }
    /** */
    get PascalMinutesPerCubicMeter() {
        if (this.pascalminutespercubicmeterLazy !== null) {
            return this.pascalminutespercubicmeterLazy;
        }
        return this.pascalminutespercubicmeterLazy = this.convertFromBase(FluidResistanceUnits.PascalMinutesPerCubicMeter);
    }
    /** */
    get PascalSecondsPerCubicCentimeter() {
        if (this.pascalsecondspercubiccentimeterLazy !== null) {
            return this.pascalsecondspercubiccentimeterLazy;
        }
        return this.pascalsecondspercubiccentimeterLazy = this.convertFromBase(FluidResistanceUnits.PascalSecondsPerCubicCentimeter);
    }
    /** */
    get PascalMinutesPerCubicCentimeter() {
        if (this.pascalminutespercubiccentimeterLazy !== null) {
            return this.pascalminutespercubiccentimeterLazy;
        }
        return this.pascalminutespercubiccentimeterLazy = this.convertFromBase(FluidResistanceUnits.PascalMinutesPerCubicCentimeter);
    }
    /** */
    get DyneSecondsPerCentimeterToTheFifth() {
        if (this.dynesecondspercentimetertothefifthLazy !== null) {
            return this.dynesecondspercentimetertothefifthLazy;
        }
        return this.dynesecondspercentimetertothefifthLazy = this.convertFromBase(FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth);
    }
    /** */
    get MillimeterMercurySecondsPerLiter() {
        if (this.millimetermercurysecondsperliterLazy !== null) {
            return this.millimetermercurysecondsperliterLazy;
        }
        return this.millimetermercurysecondsperliterLazy = this.convertFromBase(FluidResistanceUnits.MillimeterMercurySecondsPerLiter);
    }
    /** */
    get MillimeterMercuryMinutesPerLiter() {
        if (this.millimetermercuryminutesperliterLazy !== null) {
            return this.millimetermercuryminutesperliterLazy;
        }
        return this.millimetermercuryminutesperliterLazy = this.convertFromBase(FluidResistanceUnits.MillimeterMercuryMinutesPerLiter);
    }
    /** */
    get MillimeterMercurySecondsPerMilliliter() {
        if (this.millimetermercurysecondspermilliliterLazy !== null) {
            return this.millimetermercurysecondspermilliliterLazy;
        }
        return this.millimetermercurysecondspermilliliterLazy = this.convertFromBase(FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter);
    }
    /** */
    get MillimeterMercuryMinutesPerMilliliter() {
        if (this.millimetermercuryminutespermilliliterLazy !== null) {
            return this.millimetermercuryminutespermilliliterLazy;
        }
        return this.millimetermercuryminutespermilliliterLazy = this.convertFromBase(FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter);
    }
    /** */
    get MillimeterMercurySecondsPerCubicCentimeter() {
        if (this.millimetermercurysecondspercubiccentimeterLazy !== null) {
            return this.millimetermercurysecondspercubiccentimeterLazy;
        }
        return this.millimetermercurysecondspercubiccentimeterLazy = this.convertFromBase(FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter);
    }
    /** */
    get MillimeterMercuryMinutesPerCubicCentimeter() {
        if (this.millimetermercuryminutespercubiccentimeterLazy !== null) {
            return this.millimetermercuryminutespercubiccentimeterLazy;
        }
        return this.millimetermercuryminutespercubiccentimeterLazy = this.convertFromBase(FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter);
    }
    /** */
    get MillimeterMercurySecondsPerCubicMeter() {
        if (this.millimetermercurysecondspercubicmeterLazy !== null) {
            return this.millimetermercurysecondspercubicmeterLazy;
        }
        return this.millimetermercurysecondspercubicmeterLazy = this.convertFromBase(FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter);
    }
    /** */
    get MillimeterMercuryMinutesPerCubicMeter() {
        if (this.millimetermercuryminutespercubicmeterLazy !== null) {
            return this.millimetermercuryminutespercubicmeterLazy;
        }
        return this.millimetermercuryminutespercubicmeterLazy = this.convertFromBase(FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter);
    }
    /** */
    get WoodUnits() {
        if (this.woodunitsLazy !== null) {
            return this.woodunitsLazy;
        }
        return this.woodunitsLazy = this.convertFromBase(FluidResistanceUnits.WoodUnits);
    }
    /** */
    get MegapascalSecondsPerCubicMeter() {
        if (this.megapascalsecondspercubicmeterLazy !== null) {
            return this.megapascalsecondspercubicmeterLazy;
        }
        return this.megapascalsecondspercubicmeterLazy = this.convertFromBase(FluidResistanceUnits.MegapascalSecondsPerCubicMeter);
    }
    /**
     * Create a new FluidResistance instance from a PascalSecondsPerLiter
     *
     * @param value The unit as PascalSecondsPerLiter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromPascalSecondsPerLiter(value) {
        return new FluidResistance(value, FluidResistanceUnits.PascalSecondsPerLiter);
    }
    /**
     * Create a new FluidResistance instance from a PascalMinutesPerLiter
     *
     * @param value The unit as PascalMinutesPerLiter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromPascalMinutesPerLiter(value) {
        return new FluidResistance(value, FluidResistanceUnits.PascalMinutesPerLiter);
    }
    /**
     * Create a new FluidResistance instance from a PascalSecondsPerMilliliter
     *
     * @param value The unit as PascalSecondsPerMilliliter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromPascalSecondsPerMilliliter(value) {
        return new FluidResistance(value, FluidResistanceUnits.PascalSecondsPerMilliliter);
    }
    /**
     * Create a new FluidResistance instance from a PascalMinutesPerMilliliter
     *
     * @param value The unit as PascalMinutesPerMilliliter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromPascalMinutesPerMilliliter(value) {
        return new FluidResistance(value, FluidResistanceUnits.PascalMinutesPerMilliliter);
    }
    /**
     * Create a new FluidResistance instance from a PascalSecondsPerCubicMeter
     *
     * @param value The unit as PascalSecondsPerCubicMeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromPascalSecondsPerCubicMeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.PascalSecondsPerCubicMeter);
    }
    /**
     * Create a new FluidResistance instance from a PascalMinutesPerCubicMeter
     *
     * @param value The unit as PascalMinutesPerCubicMeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromPascalMinutesPerCubicMeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.PascalMinutesPerCubicMeter);
    }
    /**
     * Create a new FluidResistance instance from a PascalSecondsPerCubicCentimeter
     *
     * @param value The unit as PascalSecondsPerCubicCentimeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromPascalSecondsPerCubicCentimeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.PascalSecondsPerCubicCentimeter);
    }
    /**
     * Create a new FluidResistance instance from a PascalMinutesPerCubicCentimeter
     *
     * @param value The unit as PascalMinutesPerCubicCentimeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromPascalMinutesPerCubicCentimeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.PascalMinutesPerCubicCentimeter);
    }
    /**
     * Create a new FluidResistance instance from a DyneSecondsPerCentimeterToTheFifth
     *
     * @param value The unit as DyneSecondsPerCentimeterToTheFifth to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromDyneSecondsPerCentimeterToTheFifth(value) {
        return new FluidResistance(value, FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth);
    }
    /**
     * Create a new FluidResistance instance from a MillimeterMercurySecondsPerLiter
     *
     * @param value The unit as MillimeterMercurySecondsPerLiter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMillimeterMercurySecondsPerLiter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MillimeterMercurySecondsPerLiter);
    }
    /**
     * Create a new FluidResistance instance from a MillimeterMercuryMinutesPerLiter
     *
     * @param value The unit as MillimeterMercuryMinutesPerLiter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMillimeterMercuryMinutesPerLiter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MillimeterMercuryMinutesPerLiter);
    }
    /**
     * Create a new FluidResistance instance from a MillimeterMercurySecondsPerMilliliter
     *
     * @param value The unit as MillimeterMercurySecondsPerMilliliter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMillimeterMercurySecondsPerMilliliter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter);
    }
    /**
     * Create a new FluidResistance instance from a MillimeterMercuryMinutesPerMilliliter
     *
     * @param value The unit as MillimeterMercuryMinutesPerMilliliter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMillimeterMercuryMinutesPerMilliliter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter);
    }
    /**
     * Create a new FluidResistance instance from a MillimeterMercurySecondsPerCubicCentimeter
     *
     * @param value The unit as MillimeterMercurySecondsPerCubicCentimeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMillimeterMercurySecondsPerCubicCentimeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter);
    }
    /**
     * Create a new FluidResistance instance from a MillimeterMercuryMinutesPerCubicCentimeter
     *
     * @param value The unit as MillimeterMercuryMinutesPerCubicCentimeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMillimeterMercuryMinutesPerCubicCentimeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter);
    }
    /**
     * Create a new FluidResistance instance from a MillimeterMercurySecondsPerCubicMeter
     *
     * @param value The unit as MillimeterMercurySecondsPerCubicMeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMillimeterMercurySecondsPerCubicMeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter);
    }
    /**
     * Create a new FluidResistance instance from a MillimeterMercuryMinutesPerCubicMeter
     *
     * @param value The unit as MillimeterMercuryMinutesPerCubicMeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMillimeterMercuryMinutesPerCubicMeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter);
    }
    /**
     * Create a new FluidResistance instance from a WoodUnits
     *
     * @param value The unit as WoodUnits to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromWoodUnits(value) {
        return new FluidResistance(value, FluidResistanceUnits.WoodUnits);
    }
    /**
     * Create a new FluidResistance instance from a MegapascalSecondsPerCubicMeter
     *
     * @param value The unit as MegapascalSecondsPerCubicMeter to create a new FluidResistance from.
     * @returns The new FluidResistance instance.
     */
    static FromMegapascalSecondsPerCubicMeter(value) {
        return new FluidResistance(value, FluidResistanceUnits.MegapascalSecondsPerCubicMeter);
    }
    /**
     * Gets the base unit enumeration associated with FluidResistance
     * @returns The unit enumeration that can be used to interact with this type
     */
    static getUnitEnum() {
        return FluidResistanceUnits;
    }
    /**
     * Gets the default unit used when creating instances of the unit or its DTO
     * @returns The unit enumeration value used as a default parameter in constructor and DTO methods
     */
    static getBaseUnit() {
        return FluidResistanceUnits.PascalSecondsPerCubicMeter;
    }
    /**
     * Create API DTO represent a FluidResistance unit.
     * @param holdInUnit The specific FluidResistance unit to be used in the unit representation at the DTO
     */
    toDto(holdInUnit = FluidResistanceUnits.PascalSecondsPerCubicMeter) {
        return {
            value: this.convert(holdInUnit),
            unit: holdInUnit
        };
    }
    /**
     * Create a FluidResistance unit from an API DTO representation.
     * @param dtoFluidResistance The FluidResistance API DTO representation
     */
    static FromDto(dtoFluidResistance) {
        return new FluidResistance(dtoFluidResistance.value, dtoFluidResistance.unit);
    }
    /**
     * Convert FluidResistance to a specific unit value.
     * @param toUnit The specific unit to convert to
     * @returns The value of the specific unit provided.
     */
    convert(toUnit) {
        switch (toUnit) {
            case FluidResistanceUnits.PascalSecondsPerLiter: return this.PascalSecondsPerLiter;
            case FluidResistanceUnits.PascalMinutesPerLiter: return this.PascalMinutesPerLiter;
            case FluidResistanceUnits.PascalSecondsPerMilliliter: return this.PascalSecondsPerMilliliter;
            case FluidResistanceUnits.PascalMinutesPerMilliliter: return this.PascalMinutesPerMilliliter;
            case FluidResistanceUnits.PascalSecondsPerCubicMeter: return this.PascalSecondsPerCubicMeter;
            case FluidResistanceUnits.PascalMinutesPerCubicMeter: return this.PascalMinutesPerCubicMeter;
            case FluidResistanceUnits.PascalSecondsPerCubicCentimeter: return this.PascalSecondsPerCubicCentimeter;
            case FluidResistanceUnits.PascalMinutesPerCubicCentimeter: return this.PascalMinutesPerCubicCentimeter;
            case FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth: return this.DyneSecondsPerCentimeterToTheFifth;
            case FluidResistanceUnits.MillimeterMercurySecondsPerLiter: return this.MillimeterMercurySecondsPerLiter;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerLiter: return this.MillimeterMercuryMinutesPerLiter;
            case FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter: return this.MillimeterMercurySecondsPerMilliliter;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter: return this.MillimeterMercuryMinutesPerMilliliter;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter: return this.MillimeterMercurySecondsPerCubicCentimeter;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter: return this.MillimeterMercuryMinutesPerCubicCentimeter;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter: return this.MillimeterMercurySecondsPerCubicMeter;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter: return this.MillimeterMercuryMinutesPerCubicMeter;
            case FluidResistanceUnits.WoodUnits: return this.WoodUnits;
            case FluidResistanceUnits.MegapascalSecondsPerCubicMeter: return this.MegapascalSecondsPerCubicMeter;
            default:
                break;
        }
        return Number.NaN;
    }
    convertFromBase(toUnit) {
        if (base_unit_1.areAnyOperatorsOverridden())
            switch (toUnit) {
                case FluidResistanceUnits.PascalSecondsPerLiter: return super.internalDivide(this.value, 1e3);
                case FluidResistanceUnits.PascalMinutesPerLiter: return super.internalDivide(this.value, 6e4);
                case FluidResistanceUnits.PascalSecondsPerMilliliter: return super.internalDivide(this.value, 1e6);
                case FluidResistanceUnits.PascalMinutesPerMilliliter: return super.internalDivide(this.value, 6e7);
                case FluidResistanceUnits.PascalSecondsPerCubicMeter: return this.value;
                case FluidResistanceUnits.PascalMinutesPerCubicMeter: return super.internalDivide(this.value, 60);
                case FluidResistanceUnits.PascalSecondsPerCubicCentimeter: return super.internalDivide(this.value, 1e6);
                case FluidResistanceUnits.PascalMinutesPerCubicCentimeter: return super.internalDivide(this.value, 6e7);
                case FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth: return super.internalDivide(this.value, 1e5);
                case FluidResistanceUnits.MillimeterMercurySecondsPerLiter: return super.internalDivide(this.value, 1.33322368e5);
                case FluidResistanceUnits.MillimeterMercuryMinutesPerLiter: return super.internalDivide(this.value, 7.99934208e6);
                case FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter: return super.internalDivide(this.value, 1.33322368e8);
                case FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter: return super.internalDivide(this.value, 7.99934208e9);
                case FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter: return super.internalDivide(this.value, 1.33322368e8);
                case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter: return super.internalDivide(this.value, 7.99934208e9);
                case FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter: return super.internalDivide(this.value, 133.322368);
                case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter: return super.internalDivide(this.value, 7.99934208e3);
                case FluidResistanceUnits.WoodUnits: return super.internalDivide(this.value, 7.99934208e6);
                case FluidResistanceUnits.MegapascalSecondsPerCubicMeter: return super.internalDivide(this.value, 1000000);
                default: return Number.NaN;
            }
        switch (toUnit) {
            case FluidResistanceUnits.PascalSecondsPerLiter: return this.value / 1e3;
            case FluidResistanceUnits.PascalMinutesPerLiter: return this.value / 6e4;
            case FluidResistanceUnits.PascalSecondsPerMilliliter: return this.value / 1e6;
            case FluidResistanceUnits.PascalMinutesPerMilliliter: return this.value / 6e7;
            case FluidResistanceUnits.PascalSecondsPerCubicMeter: return this.value;
            case FluidResistanceUnits.PascalMinutesPerCubicMeter: return this.value / 60;
            case FluidResistanceUnits.PascalSecondsPerCubicCentimeter: return this.value / 1e6;
            case FluidResistanceUnits.PascalMinutesPerCubicCentimeter: return this.value / 6e7;
            case FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth: return this.value / 1e5;
            case FluidResistanceUnits.MillimeterMercurySecondsPerLiter: return this.value / 1.33322368e5;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerLiter: return this.value / 7.99934208e6;
            case FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter: return this.value / 1.33322368e8;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter: return this.value / 7.99934208e9;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter: return this.value / 1.33322368e8;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter: return this.value / 7.99934208e9;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter: return this.value / 133.322368;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter: return this.value / 7.99934208e3;
            case FluidResistanceUnits.WoodUnits: return this.value / 7.99934208e6;
            case FluidResistanceUnits.MegapascalSecondsPerCubicMeter: return (this.value) / 1000000;
            default: return Number.NaN;
        }
    }
    convertToBase(value, fromUnit) {
        if (base_unit_1.areAnyOperatorsOverridden())
            switch (fromUnit) {
                case FluidResistanceUnits.PascalSecondsPerLiter: return super.internalMultiply(value, 1e3);
                case FluidResistanceUnits.PascalMinutesPerLiter: return super.internalMultiply(value, 6e4);
                case FluidResistanceUnits.PascalSecondsPerMilliliter: return super.internalMultiply(value, 1e6);
                case FluidResistanceUnits.PascalMinutesPerMilliliter: return super.internalMultiply(value, 6e7);
                case FluidResistanceUnits.PascalSecondsPerCubicMeter: return value;
                case FluidResistanceUnits.PascalMinutesPerCubicMeter: return super.internalMultiply(value, 60);
                case FluidResistanceUnits.PascalSecondsPerCubicCentimeter: return super.internalMultiply(value, 1e6);
                case FluidResistanceUnits.PascalMinutesPerCubicCentimeter: return super.internalMultiply(value, 6e7);
                case FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth: return super.internalMultiply(value, 1e5);
                case FluidResistanceUnits.MillimeterMercurySecondsPerLiter: return super.internalMultiply(value, 1.33322368e5);
                case FluidResistanceUnits.MillimeterMercuryMinutesPerLiter: return super.internalMultiply(value, 7.99934208e6);
                case FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter: return super.internalMultiply(value, 1.33322368e8);
                case FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter: return super.internalMultiply(value, 7.99934208e9);
                case FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter: return super.internalMultiply(value, 1.33322368e8);
                case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter: return super.internalMultiply(value, 7.99934208e9);
                case FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter: return super.internalMultiply(value, 133.322368);
                case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter: return super.internalMultiply(value, 7.99934208e3);
                case FluidResistanceUnits.WoodUnits: return super.internalMultiply(value, 7.99934208e6);
                case FluidResistanceUnits.MegapascalSecondsPerCubicMeter: return super.internalMultiply(value, 1000000);
                default: return Number.NaN;
            }
        switch (fromUnit) {
            case FluidResistanceUnits.PascalSecondsPerLiter: return value * 1e3;
            case FluidResistanceUnits.PascalMinutesPerLiter: return value * 6e4;
            case FluidResistanceUnits.PascalSecondsPerMilliliter: return value * 1e6;
            case FluidResistanceUnits.PascalMinutesPerMilliliter: return value * 6e7;
            case FluidResistanceUnits.PascalSecondsPerCubicMeter: return value;
            case FluidResistanceUnits.PascalMinutesPerCubicMeter: return value * 60;
            case FluidResistanceUnits.PascalSecondsPerCubicCentimeter: return value * 1e6;
            case FluidResistanceUnits.PascalMinutesPerCubicCentimeter: return value * 6e7;
            case FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth: return value * 1e5;
            case FluidResistanceUnits.MillimeterMercurySecondsPerLiter: return value * 1.33322368e5;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerLiter: return value * 7.99934208e6;
            case FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter: return value * 1.33322368e8;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter: return value * 7.99934208e9;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter: return value * 1.33322368e8;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter: return value * 7.99934208e9;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter: return value * 133.322368;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter: return value * 7.99934208e3;
            case FluidResistanceUnits.WoodUnits: return value * 7.99934208e6;
            case FluidResistanceUnits.MegapascalSecondsPerCubicMeter: return (value) * 1000000;
            default: return Number.NaN;
        }
    }
    /**
     * Format the FluidResistance to string.
     * Note! the default format for FluidResistance is PascalSecondsPerCubicMeter.
     * To specify the unit format set the 'unit' parameter.
     * @param unit The unit to format the FluidResistance.
     * @param options The ToString options, it also can be the number of fractional digits to keep that deprecated and moved to the options object. support in number will be dropped in the upcoming versions.
     * @returns The string format of the FluidResistance.
     */
    toString(unit = FluidResistanceUnits.PascalSecondsPerCubicMeter, options) {
        if (typeof options === 'number') {
            console.warn('The number parameter is deprecated and moved to the options object. support in number will be dropped in the upcoming versions.');
            options = { fractionalDigits: options };
        }
        switch (unit) {
            case FluidResistanceUnits.PascalSecondsPerLiter:
                return super.truncateFractionDigits(this.PascalSecondsPerLiter, options) + ` Pa·s/l`;
            case FluidResistanceUnits.PascalMinutesPerLiter:
                return super.truncateFractionDigits(this.PascalMinutesPerLiter, options) + ` Pa·min/l`;
            case FluidResistanceUnits.PascalSecondsPerMilliliter:
                return super.truncateFractionDigits(this.PascalSecondsPerMilliliter, options) + ` Pa·s/ml`;
            case FluidResistanceUnits.PascalMinutesPerMilliliter:
                return super.truncateFractionDigits(this.PascalMinutesPerMilliliter, options) + ` Pa·min/ml`;
            case FluidResistanceUnits.PascalSecondsPerCubicMeter:
                return super.truncateFractionDigits(this.PascalSecondsPerCubicMeter, options) + ` Pa·s/m³`;
            case FluidResistanceUnits.PascalMinutesPerCubicMeter:
                return super.truncateFractionDigits(this.PascalMinutesPerCubicMeter, options) + ` Pa·min/m³`;
            case FluidResistanceUnits.PascalSecondsPerCubicCentimeter:
                return super.truncateFractionDigits(this.PascalSecondsPerCubicCentimeter, options) + ` Pa·s/cm³`;
            case FluidResistanceUnits.PascalMinutesPerCubicCentimeter:
                return super.truncateFractionDigits(this.PascalMinutesPerCubicCentimeter, options) + ` Pa·min/cm³`;
            case FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth:
                return super.truncateFractionDigits(this.DyneSecondsPerCentimeterToTheFifth, options) + ` dyn·s/cm⁵`;
            case FluidResistanceUnits.MillimeterMercurySecondsPerLiter:
                return super.truncateFractionDigits(this.MillimeterMercurySecondsPerLiter, options) + ` mmHg·s/l`;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerLiter:
                return super.truncateFractionDigits(this.MillimeterMercuryMinutesPerLiter, options) + ` mmHg·min/l`;
            case FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter:
                return super.truncateFractionDigits(this.MillimeterMercurySecondsPerMilliliter, options) + ` mmHg·s/ml`;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter:
                return super.truncateFractionDigits(this.MillimeterMercuryMinutesPerMilliliter, options) + ` mmHg·min/ml`;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter:
                return super.truncateFractionDigits(this.MillimeterMercurySecondsPerCubicCentimeter, options) + ` mmHg·s/cm³`;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter:
                return super.truncateFractionDigits(this.MillimeterMercuryMinutesPerCubicCentimeter, options) + ` mmHg·min/cm³`;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter:
                return super.truncateFractionDigits(this.MillimeterMercurySecondsPerCubicMeter, options) + ` mmHg·s/m³`;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter:
                return super.truncateFractionDigits(this.MillimeterMercuryMinutesPerCubicMeter, options) + ` mmHg·min/m³`;
            case FluidResistanceUnits.WoodUnits:
                return super.truncateFractionDigits(this.WoodUnits, options) + ` WU`;
            case FluidResistanceUnits.MegapascalSecondsPerCubicMeter:
                return super.truncateFractionDigits(this.MegapascalSecondsPerCubicMeter, options) + ` MPa·s/m³`;
            default:
                break;
        }
        return this.value.toString();
    }
    /**
     * Get FluidResistance unit abbreviation.
     * Note! the default abbreviation for FluidResistance is PascalSecondsPerCubicMeter.
     * To specify the unit abbreviation set the 'unitAbbreviation' parameter.
     * @param unitAbbreviation The unit abbreviation of the FluidResistance.
     * @returns The abbreviation string of FluidResistance.
     */
    getUnitAbbreviation(unitAbbreviation = FluidResistanceUnits.PascalSecondsPerCubicMeter) {
        switch (unitAbbreviation) {
            case FluidResistanceUnits.PascalSecondsPerLiter:
                return `Pa·s/l`;
            case FluidResistanceUnits.PascalMinutesPerLiter:
                return `Pa·min/l`;
            case FluidResistanceUnits.PascalSecondsPerMilliliter:
                return `Pa·s/ml`;
            case FluidResistanceUnits.PascalMinutesPerMilliliter:
                return `Pa·min/ml`;
            case FluidResistanceUnits.PascalSecondsPerCubicMeter:
                return `Pa·s/m³`;
            case FluidResistanceUnits.PascalMinutesPerCubicMeter:
                return `Pa·min/m³`;
            case FluidResistanceUnits.PascalSecondsPerCubicCentimeter:
                return `Pa·s/cm³`;
            case FluidResistanceUnits.PascalMinutesPerCubicCentimeter:
                return `Pa·min/cm³`;
            case FluidResistanceUnits.DyneSecondsPerCentimeterToTheFifth:
                return `dyn·s/cm⁵`;
            case FluidResistanceUnits.MillimeterMercurySecondsPerLiter:
                return `mmHg·s/l`;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerLiter:
                return `mmHg·min/l`;
            case FluidResistanceUnits.MillimeterMercurySecondsPerMilliliter:
                return `mmHg·s/ml`;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerMilliliter:
                return `mmHg·min/ml`;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicCentimeter:
                return `mmHg·s/cm³`;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicCentimeter:
                return `mmHg·min/cm³`;
            case FluidResistanceUnits.MillimeterMercurySecondsPerCubicMeter:
                return `mmHg·s/m³`;
            case FluidResistanceUnits.MillimeterMercuryMinutesPerCubicMeter:
                return `mmHg·min/m³`;
            case FluidResistanceUnits.WoodUnits:
                return `WU`;
            case FluidResistanceUnits.MegapascalSecondsPerCubicMeter:
                return `MPa·s/m³`;
            default:
                break;
        }
        return '';
    }
    /**
     * Check if the given FluidResistance are equals to the current FluidResistance.
     * @param fluidResistance The other FluidResistance.
     * @returns True if the given FluidResistance are equal to the current FluidResistance.
     */
    equals(fluidResistance) {
        return super.internalEquals(this.value, fluidResistance.BaseValue);
    }
    /**
     * Compare the given FluidResistance against the current FluidResistance.
     * @param fluidResistance The other FluidResistance.
     * @returns 0 if they are equal, -1 if the current FluidResistance is less then other, 1 if the current FluidResistance is greater then other.
     */
    compareTo(fluidResistance) {
        return super.internalCompareTo(this.value, fluidResistance.BaseValue);
    }
    /**
     * Add the given FluidResistance with the current FluidResistance.
     * @param fluidResistance The other FluidResistance.
     * @returns A new FluidResistance instance with the results.
     */
    add(fluidResistance) {
        return new FluidResistance(super.internalAdd(this.value, fluidResistance.BaseValue));
    }
    /**
     * Subtract the given FluidResistance with the current FluidResistance.
     * @param fluidResistance The other FluidResistance.
     * @returns A new FluidResistance instance with the results.
     */
    subtract(fluidResistance) {
        return new FluidResistance(super.internalSubtract(this.value, fluidResistance.BaseValue));
    }
    /**
     * Multiply the given FluidResistance with the current FluidResistance.
     * @param fluidResistance The other FluidResistance.
     * @returns A new FluidResistance instance with the results.
     */
    multiply(fluidResistance) {
        return new FluidResistance(super.internalMultiply(this.value, fluidResistance.BaseValue));
    }
    /**
     * Divide the given FluidResistance with the current FluidResistance.
     * @param fluidResistance The other FluidResistance.
     * @returns A new FluidResistance instance with the results.
     */
    divide(fluidResistance) {
        return new FluidResistance(super.internalDivide(this.value, fluidResistance.BaseValue));
    }
    /**
     * Modulo the given FluidResistance with the current FluidResistance.
     * @param fluidResistance The other FluidResistance.
     * @returns A new FluidResistance instance with the results.
     */
    modulo(fluidResistance) {
        return new FluidResistance(super.internalModulo(this.value, fluidResistance.BaseValue));
    }
    /**
     * Pow the given FluidResistance with the current FluidResistance.
     * @param fluidResistance The other FluidResistance.
     * @returns A new FluidResistance instance with the results.
     */
    pow(fluidResistance) {
        return new FluidResistance(super.internalPow(this.value, fluidResistance.BaseValue));
    }
}
exports.FluidResistance = FluidResistance;
