import { BaseUnit, ToStringOptions } from "../base-unit";
/** API DTO represents a RadiationEquivalentDoseRate */
export interface RadiationEquivalentDoseRateDto {
    /** The value of the RadiationEquivalentDoseRate */
    value: number;
    /**  The specific unit that the RadiationEquivalentDoseRate value is representing */
    unit: RadiationEquivalentDoseRateUnits;
}
/** RadiationEquivalentDoseRateUnits enumeration */
export declare enum RadiationEquivalentDoseRateUnits {
    /** */
    SievertsPerHour = "SievertPerHour",
    /** */
    SievertsPerSecond = "SievertPerSecond",
    /** */
    RoentgensEquivalentManPerHour = "RoentgenEquivalentManPerHour",
    /** */
    NanosievertsPerHour = "NanosievertPerHour",
    /** */
    MicrosievertsPerHour = "MicrosievertPerHour",
    /** */
    MillisievertsPerHour = "MillisievertPerHour",
    /** */
    NanosievertsPerSecond = "NanosievertPerSecond",
    /** */
    MicrosievertsPerSecond = "MicrosievertPerSecond",
    /** */
    MillisievertsPerSecond = "MillisievertPerSecond",
    /** */
    MilliroentgensEquivalentManPerHour = "MilliroentgenEquivalentManPerHour"
}
/** A dose rate is quantity of radiation absorbed or delivered per unit time. */
export declare class RadiationEquivalentDoseRate extends BaseUnit {
    protected value: number;
    private sievertsperhourLazy;
    private sievertspersecondLazy;
    private roentgensequivalentmanperhourLazy;
    private nanosievertsperhourLazy;
    private microsievertsperhourLazy;
    private millisievertsperhourLazy;
    private nanosievertspersecondLazy;
    private microsievertspersecondLazy;
    private millisievertspersecondLazy;
    private milliroentgensequivalentmanperhourLazy;
    /**
     * Create a new RadiationEquivalentDoseRate.
     * @param value The value.
     * @param fromUnit The ‘RadiationEquivalentDoseRate’ unit to create from.
     * The default unit is SievertsPerSecond
     */
    constructor(value: number, fromUnit?: RadiationEquivalentDoseRateUnits);
    /**
     * The base value of RadiationEquivalentDoseRate is SievertsPerSecond.
     * This accessor used when needs a value for calculations and it's better to use directly the base value
     */
    get BaseValue(): number;
    /** Gets the default unit used when creating instances of the unit or its DTO */
    protected get baseUnit(): RadiationEquivalentDoseRateUnits.SievertsPerSecond;
    /** */
    get SievertsPerHour(): number;
    /** */
    get SievertsPerSecond(): number;
    /** */
    get RoentgensEquivalentManPerHour(): number;
    /** */
    get NanosievertsPerHour(): number;
    /** */
    get MicrosievertsPerHour(): number;
    /** */
    get MillisievertsPerHour(): number;
    /** */
    get NanosievertsPerSecond(): number;
    /** */
    get MicrosievertsPerSecond(): number;
    /** */
    get MillisievertsPerSecond(): number;
    /** */
    get MilliroentgensEquivalentManPerHour(): number;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a SievertsPerHour
     *
     * @param value The unit as SievertsPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromSievertsPerHour(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a SievertsPerSecond
     *
     * @param value The unit as SievertsPerSecond to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromSievertsPerSecond(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a RoentgensEquivalentManPerHour
     *
     * @param value The unit as RoentgensEquivalentManPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromRoentgensEquivalentManPerHour(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a NanosievertsPerHour
     *
     * @param value The unit as NanosievertsPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromNanosievertsPerHour(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MicrosievertsPerHour
     *
     * @param value The unit as MicrosievertsPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMicrosievertsPerHour(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MillisievertsPerHour
     *
     * @param value The unit as MillisievertsPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMillisievertsPerHour(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a NanosievertsPerSecond
     *
     * @param value The unit as NanosievertsPerSecond to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromNanosievertsPerSecond(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MicrosievertsPerSecond
     *
     * @param value The unit as MicrosievertsPerSecond to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMicrosievertsPerSecond(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MillisievertsPerSecond
     *
     * @param value The unit as MillisievertsPerSecond to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMillisievertsPerSecond(value: number): RadiationEquivalentDoseRate;
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MilliroentgensEquivalentManPerHour
     *
     * @param value The unit as MilliroentgensEquivalentManPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMilliroentgensEquivalentManPerHour(value: number): RadiationEquivalentDoseRate;
    /**
     * Gets the base unit enumeration associated with RadiationEquivalentDoseRate
     * @returns The unit enumeration that can be used to interact with this type
     */
    protected static getUnitEnum(): typeof RadiationEquivalentDoseRateUnits;
    /**
     * Gets the default unit used when creating instances of the unit or its DTO
     * @returns The unit enumeration value used as a default parameter in constructor and DTO methods
     */
    protected static getBaseUnit(): RadiationEquivalentDoseRateUnits.SievertsPerSecond;
    /**
     * Create API DTO represent a RadiationEquivalentDoseRate unit.
     * @param holdInUnit The specific RadiationEquivalentDoseRate unit to be used in the unit representation at the DTO
     */
    toDto(holdInUnit?: RadiationEquivalentDoseRateUnits): RadiationEquivalentDoseRateDto;
    /**
     * Create a RadiationEquivalentDoseRate unit from an API DTO representation.
     * @param dtoRadiationEquivalentDoseRate The RadiationEquivalentDoseRate API DTO representation
     */
    static FromDto(dtoRadiationEquivalentDoseRate: RadiationEquivalentDoseRateDto): RadiationEquivalentDoseRate;
    /**
     * Convert RadiationEquivalentDoseRate to a specific unit value.
     * @param toUnit The specific unit to convert to
     * @returns The value of the specific unit provided.
     */
    convert(toUnit: RadiationEquivalentDoseRateUnits): number;
    private convertFromBase;
    private convertToBase;
    /**
     * Format the RadiationEquivalentDoseRate to string.
     * Note! the default format for RadiationEquivalentDoseRate is SievertsPerSecond.
     * To specify the unit format set the 'unit' parameter.
     * @param unit The unit to format the RadiationEquivalentDoseRate.
     * @param options The ToString options, it also can be the number of fractional digits to keep that deprecated and moved to the options object. support in number will be dropped in the upcoming versions.
     * @returns The string format of the RadiationEquivalentDoseRate.
     */
    toString(unit?: RadiationEquivalentDoseRateUnits, options?: number | ToStringOptions): string;
    /**
     * Get RadiationEquivalentDoseRate unit abbreviation.
     * Note! the default abbreviation for RadiationEquivalentDoseRate is SievertsPerSecond.
     * To specify the unit abbreviation set the 'unitAbbreviation' parameter.
     * @param unitAbbreviation The unit abbreviation of the RadiationEquivalentDoseRate.
     * @returns The abbreviation string of RadiationEquivalentDoseRate.
     */
    getUnitAbbreviation(unitAbbreviation?: RadiationEquivalentDoseRateUnits): string;
    /**
     * Check if the given RadiationEquivalentDoseRate are equals to the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns True if the given RadiationEquivalentDoseRate are equal to the current RadiationEquivalentDoseRate.
     */
    equals(radiationEquivalentDoseRate: RadiationEquivalentDoseRate): boolean;
    /**
     * Compare the given RadiationEquivalentDoseRate against the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns 0 if they are equal, -1 if the current RadiationEquivalentDoseRate is less then other, 1 if the current RadiationEquivalentDoseRate is greater then other.
     */
    compareTo(radiationEquivalentDoseRate: RadiationEquivalentDoseRate): number;
    /**
     * Add the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    add(radiationEquivalentDoseRate: RadiationEquivalentDoseRate): RadiationEquivalentDoseRate;
    /**
     * Subtract the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    subtract(radiationEquivalentDoseRate: RadiationEquivalentDoseRate): RadiationEquivalentDoseRate;
    /**
     * Multiply the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    multiply(radiationEquivalentDoseRate: RadiationEquivalentDoseRate): RadiationEquivalentDoseRate;
    /**
     * Divide the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    divide(radiationEquivalentDoseRate: RadiationEquivalentDoseRate): RadiationEquivalentDoseRate;
    /**
     * Modulo the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    modulo(radiationEquivalentDoseRate: RadiationEquivalentDoseRate): RadiationEquivalentDoseRate;
    /**
     * Pow the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    pow(radiationEquivalentDoseRate: RadiationEquivalentDoseRate): RadiationEquivalentDoseRate;
}
