"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadiationEquivalentDoseRate = exports.RadiationEquivalentDoseRateUnits = void 0;
const base_unit_1 = require("../base-unit");
/** RadiationEquivalentDoseRateUnits enumeration */
var RadiationEquivalentDoseRateUnits;
(function (RadiationEquivalentDoseRateUnits) {
    /** */
    RadiationEquivalentDoseRateUnits["SievertsPerHour"] = "SievertPerHour";
    /** */
    RadiationEquivalentDoseRateUnits["SievertsPerSecond"] = "SievertPerSecond";
    /** */
    RadiationEquivalentDoseRateUnits["RoentgensEquivalentManPerHour"] = "RoentgenEquivalentManPerHour";
    /** */
    RadiationEquivalentDoseRateUnits["NanosievertsPerHour"] = "NanosievertPerHour";
    /** */
    RadiationEquivalentDoseRateUnits["MicrosievertsPerHour"] = "MicrosievertPerHour";
    /** */
    RadiationEquivalentDoseRateUnits["MillisievertsPerHour"] = "MillisievertPerHour";
    /** */
    RadiationEquivalentDoseRateUnits["NanosievertsPerSecond"] = "NanosievertPerSecond";
    /** */
    RadiationEquivalentDoseRateUnits["MicrosievertsPerSecond"] = "MicrosievertPerSecond";
    /** */
    RadiationEquivalentDoseRateUnits["MillisievertsPerSecond"] = "MillisievertPerSecond";
    /** */
    RadiationEquivalentDoseRateUnits["MilliroentgensEquivalentManPerHour"] = "MilliroentgenEquivalentManPerHour";
})(RadiationEquivalentDoseRateUnits = exports.RadiationEquivalentDoseRateUnits || (exports.RadiationEquivalentDoseRateUnits = {}));
/** A dose rate is quantity of radiation absorbed or delivered per unit time. */
class RadiationEquivalentDoseRate extends base_unit_1.BaseUnit {
    /**
     * Create a new RadiationEquivalentDoseRate.
     * @param value The value.
     * @param fromUnit The ‘RadiationEquivalentDoseRate’ unit to create from.
     * The default unit is SievertsPerSecond
     */
    constructor(value, fromUnit = RadiationEquivalentDoseRateUnits.SievertsPerSecond) {
        super();
        this.sievertsperhourLazy = null;
        this.sievertspersecondLazy = null;
        this.roentgensequivalentmanperhourLazy = null;
        this.nanosievertsperhourLazy = null;
        this.microsievertsperhourLazy = null;
        this.millisievertsperhourLazy = null;
        this.nanosievertspersecondLazy = null;
        this.microsievertspersecondLazy = null;
        this.millisievertspersecondLazy = null;
        this.milliroentgensequivalentmanperhourLazy = null;
        if (value === undefined || value === null || Number.isNaN(value)) {
            throw new TypeError('invalid unit value ‘' + value + '’');
        }
        this.value = this.convertToBase(value, fromUnit);
    }
    /**
     * The base value of RadiationEquivalentDoseRate is SievertsPerSecond.
     * This accessor used when needs a value for calculations and it's better to use directly the base value
     */
    get BaseValue() {
        return this.value;
    }
    /** Gets the default unit used when creating instances of the unit or its DTO */
    get baseUnit() {
        return RadiationEquivalentDoseRateUnits.SievertsPerSecond;
    }
    /** */
    get SievertsPerHour() {
        if (this.sievertsperhourLazy !== null) {
            return this.sievertsperhourLazy;
        }
        return this.sievertsperhourLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.SievertsPerHour);
    }
    /** */
    get SievertsPerSecond() {
        if (this.sievertspersecondLazy !== null) {
            return this.sievertspersecondLazy;
        }
        return this.sievertspersecondLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.SievertsPerSecond);
    }
    /** */
    get RoentgensEquivalentManPerHour() {
        if (this.roentgensequivalentmanperhourLazy !== null) {
            return this.roentgensequivalentmanperhourLazy;
        }
        return this.roentgensequivalentmanperhourLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour);
    }
    /** */
    get NanosievertsPerHour() {
        if (this.nanosievertsperhourLazy !== null) {
            return this.nanosievertsperhourLazy;
        }
        return this.nanosievertsperhourLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.NanosievertsPerHour);
    }
    /** */
    get MicrosievertsPerHour() {
        if (this.microsievertsperhourLazy !== null) {
            return this.microsievertsperhourLazy;
        }
        return this.microsievertsperhourLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.MicrosievertsPerHour);
    }
    /** */
    get MillisievertsPerHour() {
        if (this.millisievertsperhourLazy !== null) {
            return this.millisievertsperhourLazy;
        }
        return this.millisievertsperhourLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.MillisievertsPerHour);
    }
    /** */
    get NanosievertsPerSecond() {
        if (this.nanosievertspersecondLazy !== null) {
            return this.nanosievertspersecondLazy;
        }
        return this.nanosievertspersecondLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.NanosievertsPerSecond);
    }
    /** */
    get MicrosievertsPerSecond() {
        if (this.microsievertspersecondLazy !== null) {
            return this.microsievertspersecondLazy;
        }
        return this.microsievertspersecondLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond);
    }
    /** */
    get MillisievertsPerSecond() {
        if (this.millisievertspersecondLazy !== null) {
            return this.millisievertspersecondLazy;
        }
        return this.millisievertspersecondLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.MillisievertsPerSecond);
    }
    /** */
    get MilliroentgensEquivalentManPerHour() {
        if (this.milliroentgensequivalentmanperhourLazy !== null) {
            return this.milliroentgensequivalentmanperhourLazy;
        }
        return this.milliroentgensequivalentmanperhourLazy = this.convertFromBase(RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a SievertsPerHour
     *
     * @param value The unit as SievertsPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromSievertsPerHour(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.SievertsPerHour);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a SievertsPerSecond
     *
     * @param value The unit as SievertsPerSecond to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromSievertsPerSecond(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.SievertsPerSecond);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a RoentgensEquivalentManPerHour
     *
     * @param value The unit as RoentgensEquivalentManPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromRoentgensEquivalentManPerHour(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a NanosievertsPerHour
     *
     * @param value The unit as NanosievertsPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromNanosievertsPerHour(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.NanosievertsPerHour);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MicrosievertsPerHour
     *
     * @param value The unit as MicrosievertsPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMicrosievertsPerHour(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.MicrosievertsPerHour);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MillisievertsPerHour
     *
     * @param value The unit as MillisievertsPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMillisievertsPerHour(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.MillisievertsPerHour);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a NanosievertsPerSecond
     *
     * @param value The unit as NanosievertsPerSecond to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromNanosievertsPerSecond(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.NanosievertsPerSecond);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MicrosievertsPerSecond
     *
     * @param value The unit as MicrosievertsPerSecond to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMicrosievertsPerSecond(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MillisievertsPerSecond
     *
     * @param value The unit as MillisievertsPerSecond to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMillisievertsPerSecond(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.MillisievertsPerSecond);
    }
    /**
     * Create a new RadiationEquivalentDoseRate instance from a MilliroentgensEquivalentManPerHour
     *
     * @param value The unit as MilliroentgensEquivalentManPerHour to create a new RadiationEquivalentDoseRate from.
     * @returns The new RadiationEquivalentDoseRate instance.
     */
    static FromMilliroentgensEquivalentManPerHour(value) {
        return new RadiationEquivalentDoseRate(value, RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour);
    }
    /**
     * Gets the base unit enumeration associated with RadiationEquivalentDoseRate
     * @returns The unit enumeration that can be used to interact with this type
     */
    static getUnitEnum() {
        return RadiationEquivalentDoseRateUnits;
    }
    /**
     * Gets the default unit used when creating instances of the unit or its DTO
     * @returns The unit enumeration value used as a default parameter in constructor and DTO methods
     */
    static getBaseUnit() {
        return RadiationEquivalentDoseRateUnits.SievertsPerSecond;
    }
    /**
     * Create API DTO represent a RadiationEquivalentDoseRate unit.
     * @param holdInUnit The specific RadiationEquivalentDoseRate unit to be used in the unit representation at the DTO
     */
    toDto(holdInUnit = RadiationEquivalentDoseRateUnits.SievertsPerSecond) {
        return {
            value: this.convert(holdInUnit),
            unit: holdInUnit
        };
    }
    /**
     * Create a RadiationEquivalentDoseRate unit from an API DTO representation.
     * @param dtoRadiationEquivalentDoseRate The RadiationEquivalentDoseRate API DTO representation
     */
    static FromDto(dtoRadiationEquivalentDoseRate) {
        return new RadiationEquivalentDoseRate(dtoRadiationEquivalentDoseRate.value, dtoRadiationEquivalentDoseRate.unit);
    }
    /**
     * Convert RadiationEquivalentDoseRate to a specific unit value.
     * @param toUnit The specific unit to convert to
     * @returns The value of the specific unit provided.
     */
    convert(toUnit) {
        switch (toUnit) {
            case RadiationEquivalentDoseRateUnits.SievertsPerHour: return this.SievertsPerHour;
            case RadiationEquivalentDoseRateUnits.SievertsPerSecond: return this.SievertsPerSecond;
            case RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour: return this.RoentgensEquivalentManPerHour;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerHour: return this.NanosievertsPerHour;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerHour: return this.MicrosievertsPerHour;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerHour: return this.MillisievertsPerHour;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerSecond: return this.NanosievertsPerSecond;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond: return this.MicrosievertsPerSecond;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerSecond: return this.MillisievertsPerSecond;
            case RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour: return this.MilliroentgensEquivalentManPerHour;
            default:
                break;
        }
        return Number.NaN;
    }
    convertFromBase(toUnit) {
        if (base_unit_1.areAnyOperatorsOverridden())
            switch (toUnit) {
                case RadiationEquivalentDoseRateUnits.SievertsPerHour: return super.internalMultiply(this.value, 3600);
                case RadiationEquivalentDoseRateUnits.SievertsPerSecond: return this.value;
                case RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour: {
                    const v3 = super.internalMultiply(this.value, 100);
                    return super.internalMultiply(v3, 3600);
                }
                case RadiationEquivalentDoseRateUnits.NanosievertsPerHour: {
                    const v3 = super.internalMultiply(this.value, 3600);
                    return super.internalDivide(v3, 1e-9);
                }
                case RadiationEquivalentDoseRateUnits.MicrosievertsPerHour: {
                    const v3 = super.internalMultiply(this.value, 3600);
                    return super.internalDivide(v3, 0.000001);
                }
                case RadiationEquivalentDoseRateUnits.MillisievertsPerHour: {
                    const v3 = super.internalMultiply(this.value, 3600);
                    return super.internalDivide(v3, 0.001);
                }
                case RadiationEquivalentDoseRateUnits.NanosievertsPerSecond: return super.internalDivide(this.value, 1e-9);
                case RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond: return super.internalDivide(this.value, 0.000001);
                case RadiationEquivalentDoseRateUnits.MillisievertsPerSecond: return super.internalDivide(this.value, 0.001);
                case RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour: {
                    const v3 = super.internalMultiply(this.value, 100);
                    const v5 = super.internalMultiply(v3, 3600);
                    return super.internalDivide(v5, 0.001);
                }
                default: return Number.NaN;
            }
        switch (toUnit) {
            case RadiationEquivalentDoseRateUnits.SievertsPerHour: return this.value * 3600;
            case RadiationEquivalentDoseRateUnits.SievertsPerSecond: return this.value;
            case RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour: return this.value * 100 * 3600;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerHour: return (this.value * 3600) / 1e-9;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerHour: return (this.value * 3600) / 0.000001;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerHour: return (this.value * 3600) / 0.001;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerSecond: return (this.value) / 1e-9;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond: return (this.value) / 0.000001;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerSecond: return (this.value) / 0.001;
            case RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour: return (this.value * 100 * 3600) / 0.001;
            default: return Number.NaN;
        }
    }
    convertToBase(value, fromUnit) {
        if (base_unit_1.areAnyOperatorsOverridden())
            switch (fromUnit) {
                case RadiationEquivalentDoseRateUnits.SievertsPerHour: return super.internalDivide(value, 3600);
                case RadiationEquivalentDoseRateUnits.SievertsPerSecond: return value;
                case RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour: {
                    const v3 = super.internalDivide(value, 100);
                    return super.internalDivide(v3, 3600);
                }
                case RadiationEquivalentDoseRateUnits.NanosievertsPerHour: {
                    const v3 = super.internalDivide(value, 3600);
                    return super.internalMultiply(v3, 1e-9);
                }
                case RadiationEquivalentDoseRateUnits.MicrosievertsPerHour: {
                    const v3 = super.internalDivide(value, 3600);
                    return super.internalMultiply(v3, 0.000001);
                }
                case RadiationEquivalentDoseRateUnits.MillisievertsPerHour: {
                    const v3 = super.internalDivide(value, 3600);
                    return super.internalMultiply(v3, 0.001);
                }
                case RadiationEquivalentDoseRateUnits.NanosievertsPerSecond: return super.internalMultiply(value, 1e-9);
                case RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond: return super.internalMultiply(value, 0.000001);
                case RadiationEquivalentDoseRateUnits.MillisievertsPerSecond: return super.internalMultiply(value, 0.001);
                case RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour: {
                    const v3 = super.internalDivide(value, 100);
                    const v5 = super.internalDivide(v3, 3600);
                    return super.internalMultiply(v5, 0.001);
                }
                default: return Number.NaN;
            }
        switch (fromUnit) {
            case RadiationEquivalentDoseRateUnits.SievertsPerHour: return value / 3600;
            case RadiationEquivalentDoseRateUnits.SievertsPerSecond: return value;
            case RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour: return value / 100 / 3600;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerHour: return (value / 3600) * 1e-9;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerHour: return (value / 3600) * 0.000001;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerHour: return (value / 3600) * 0.001;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerSecond: return (value) * 1e-9;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond: return (value) * 0.000001;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerSecond: return (value) * 0.001;
            case RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour: return (value / 100 / 3600) * 0.001;
            default: return Number.NaN;
        }
    }
    /**
     * Format the RadiationEquivalentDoseRate to string.
     * Note! the default format for RadiationEquivalentDoseRate is SievertsPerSecond.
     * To specify the unit format set the 'unit' parameter.
     * @param unit The unit to format the RadiationEquivalentDoseRate.
     * @param options The ToString options, it also can be the number of fractional digits to keep that deprecated and moved to the options object. support in number will be dropped in the upcoming versions.
     * @returns The string format of the RadiationEquivalentDoseRate.
     */
    toString(unit = RadiationEquivalentDoseRateUnits.SievertsPerSecond, options) {
        if (typeof options === 'number') {
            console.warn('The number parameter is deprecated and moved to the options object. support in number will be dropped in the upcoming versions.');
            options = { fractionalDigits: options };
        }
        switch (unit) {
            case RadiationEquivalentDoseRateUnits.SievertsPerHour:
                return super.truncateFractionDigits(this.SievertsPerHour, options) + ` Sv/h`;
            case RadiationEquivalentDoseRateUnits.SievertsPerSecond:
                return super.truncateFractionDigits(this.SievertsPerSecond, options) + ` Sv/s`;
            case RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour:
                return super.truncateFractionDigits(this.RoentgensEquivalentManPerHour, options) + ` rem/h`;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerHour:
                return super.truncateFractionDigits(this.NanosievertsPerHour, options) + ` nSv/h`;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerHour:
                return super.truncateFractionDigits(this.MicrosievertsPerHour, options) + ` μSv/h`;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerHour:
                return super.truncateFractionDigits(this.MillisievertsPerHour, options) + ` mSv/h`;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerSecond:
                return super.truncateFractionDigits(this.NanosievertsPerSecond, options) + ` nSv/s`;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond:
                return super.truncateFractionDigits(this.MicrosievertsPerSecond, options) + ` μSv/s`;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerSecond:
                return super.truncateFractionDigits(this.MillisievertsPerSecond, options) + ` mSv/s`;
            case RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour:
                return super.truncateFractionDigits(this.MilliroentgensEquivalentManPerHour, options) + ` mrem/h`;
            default:
                break;
        }
        return this.value.toString();
    }
    /**
     * Get RadiationEquivalentDoseRate unit abbreviation.
     * Note! the default abbreviation for RadiationEquivalentDoseRate is SievertsPerSecond.
     * To specify the unit abbreviation set the 'unitAbbreviation' parameter.
     * @param unitAbbreviation The unit abbreviation of the RadiationEquivalentDoseRate.
     * @returns The abbreviation string of RadiationEquivalentDoseRate.
     */
    getUnitAbbreviation(unitAbbreviation = RadiationEquivalentDoseRateUnits.SievertsPerSecond) {
        switch (unitAbbreviation) {
            case RadiationEquivalentDoseRateUnits.SievertsPerHour:
                return `Sv/h`;
            case RadiationEquivalentDoseRateUnits.SievertsPerSecond:
                return `Sv/s`;
            case RadiationEquivalentDoseRateUnits.RoentgensEquivalentManPerHour:
                return `rem/h`;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerHour:
                return `nSv/h`;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerHour:
                return `μSv/h`;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerHour:
                return `mSv/h`;
            case RadiationEquivalentDoseRateUnits.NanosievertsPerSecond:
                return `nSv/s`;
            case RadiationEquivalentDoseRateUnits.MicrosievertsPerSecond:
                return `μSv/s`;
            case RadiationEquivalentDoseRateUnits.MillisievertsPerSecond:
                return `mSv/s`;
            case RadiationEquivalentDoseRateUnits.MilliroentgensEquivalentManPerHour:
                return `mrem/h`;
            default:
                break;
        }
        return '';
    }
    /**
     * Check if the given RadiationEquivalentDoseRate are equals to the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns True if the given RadiationEquivalentDoseRate are equal to the current RadiationEquivalentDoseRate.
     */
    equals(radiationEquivalentDoseRate) {
        return super.internalEquals(this.value, radiationEquivalentDoseRate.BaseValue);
    }
    /**
     * Compare the given RadiationEquivalentDoseRate against the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns 0 if they are equal, -1 if the current RadiationEquivalentDoseRate is less then other, 1 if the current RadiationEquivalentDoseRate is greater then other.
     */
    compareTo(radiationEquivalentDoseRate) {
        return super.internalCompareTo(this.value, radiationEquivalentDoseRate.BaseValue);
    }
    /**
     * Add the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    add(radiationEquivalentDoseRate) {
        return new RadiationEquivalentDoseRate(super.internalAdd(this.value, radiationEquivalentDoseRate.BaseValue));
    }
    /**
     * Subtract the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    subtract(radiationEquivalentDoseRate) {
        return new RadiationEquivalentDoseRate(super.internalSubtract(this.value, radiationEquivalentDoseRate.BaseValue));
    }
    /**
     * Multiply the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    multiply(radiationEquivalentDoseRate) {
        return new RadiationEquivalentDoseRate(super.internalMultiply(this.value, radiationEquivalentDoseRate.BaseValue));
    }
    /**
     * Divide the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    divide(radiationEquivalentDoseRate) {
        return new RadiationEquivalentDoseRate(super.internalDivide(this.value, radiationEquivalentDoseRate.BaseValue));
    }
    /**
     * Modulo the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    modulo(radiationEquivalentDoseRate) {
        return new RadiationEquivalentDoseRate(super.internalModulo(this.value, radiationEquivalentDoseRate.BaseValue));
    }
    /**
     * Pow the given RadiationEquivalentDoseRate with the current RadiationEquivalentDoseRate.
     * @param radiationEquivalentDoseRate The other RadiationEquivalentDoseRate.
     * @returns A new RadiationEquivalentDoseRate instance with the results.
     */
    pow(radiationEquivalentDoseRate) {
        return new RadiationEquivalentDoseRate(super.internalPow(this.value, radiationEquivalentDoseRate.BaseValue));
    }
}
exports.RadiationEquivalentDoseRate = RadiationEquivalentDoseRate;
