import { BaseUnit, ToStringOptions } from "../base-unit";
/** API DTO represents a RotationalStiffness */
export interface RotationalStiffnessDto {
    /** The value of the RotationalStiffness */
    value: number;
    /**  The specific unit that the RotationalStiffness value is representing */
    unit: RotationalStiffnessUnits;
}
/** RotationalStiffnessUnits enumeration */
export declare enum RotationalStiffnessUnits {
    /** */
    NewtonMetersPerRadian = "NewtonMeterPerRadian",
    /** */
    PoundForceFeetPerDegrees = "PoundForceFootPerDegrees",
    /** */
    KilopoundForceFeetPerDegrees = "KilopoundForceFootPerDegrees",
    /** */
    NewtonMillimetersPerDegree = "NewtonMillimeterPerDegree",
    /** */
    NewtonMetersPerDegree = "NewtonMeterPerDegree",
    /** */
    NewtonMillimetersPerRadian = "NewtonMillimeterPerRadian",
    /** */
    PoundForceFeetPerRadian = "PoundForceFeetPerRadian",
    /** */
    KilonewtonMetersPerRadian = "KilonewtonMeterPerRadian",
    /** */
    MeganewtonMetersPerRadian = "MeganewtonMeterPerRadian",
    /** */
    NanonewtonMillimetersPerDegree = "NanonewtonMillimeterPerDegree",
    /** */
    MicronewtonMillimetersPerDegree = "MicronewtonMillimeterPerDegree",
    /** */
    MillinewtonMillimetersPerDegree = "MillinewtonMillimeterPerDegree",
    /** */
    CentinewtonMillimetersPerDegree = "CentinewtonMillimeterPerDegree",
    /** */
    DecinewtonMillimetersPerDegree = "DecinewtonMillimeterPerDegree",
    /** */
    DecanewtonMillimetersPerDegree = "DecanewtonMillimeterPerDegree",
    /** */
    KilonewtonMillimetersPerDegree = "KilonewtonMillimeterPerDegree",
    /** */
    MeganewtonMillimetersPerDegree = "MeganewtonMillimeterPerDegree",
    /** */
    NanonewtonMetersPerDegree = "NanonewtonMeterPerDegree",
    /** */
    MicronewtonMetersPerDegree = "MicronewtonMeterPerDegree",
    /** */
    MillinewtonMetersPerDegree = "MillinewtonMeterPerDegree",
    /** */
    CentinewtonMetersPerDegree = "CentinewtonMeterPerDegree",
    /** */
    DecinewtonMetersPerDegree = "DecinewtonMeterPerDegree",
    /** */
    DecanewtonMetersPerDegree = "DecanewtonMeterPerDegree",
    /** */
    KilonewtonMetersPerDegree = "KilonewtonMeterPerDegree",
    /** */
    MeganewtonMetersPerDegree = "MeganewtonMeterPerDegree",
    /** */
    NanonewtonMillimetersPerRadian = "NanonewtonMillimeterPerRadian",
    /** */
    MicronewtonMillimetersPerRadian = "MicronewtonMillimeterPerRadian",
    /** */
    MillinewtonMillimetersPerRadian = "MillinewtonMillimeterPerRadian",
    /** */
    CentinewtonMillimetersPerRadian = "CentinewtonMillimeterPerRadian",
    /** */
    DecinewtonMillimetersPerRadian = "DecinewtonMillimeterPerRadian",
    /** */
    DecanewtonMillimetersPerRadian = "DecanewtonMillimeterPerRadian",
    /** */
    KilonewtonMillimetersPerRadian = "KilonewtonMillimeterPerRadian",
    /** */
    MeganewtonMillimetersPerRadian = "MeganewtonMillimeterPerRadian"
}
/** https://en.wikipedia.org/wiki/Stiffness#Rotational_stiffness */
export declare class RotationalStiffness extends BaseUnit {
    protected value: number;
    private newtonmetersperradianLazy;
    private poundforcefeetperdegreesLazy;
    private kilopoundforcefeetperdegreesLazy;
    private newtonmillimetersperdegreeLazy;
    private newtonmetersperdegreeLazy;
    private newtonmillimetersperradianLazy;
    private poundforcefeetperradianLazy;
    private kilonewtonmetersperradianLazy;
    private meganewtonmetersperradianLazy;
    private nanonewtonmillimetersperdegreeLazy;
    private micronewtonmillimetersperdegreeLazy;
    private millinewtonmillimetersperdegreeLazy;
    private centinewtonmillimetersperdegreeLazy;
    private decinewtonmillimetersperdegreeLazy;
    private decanewtonmillimetersperdegreeLazy;
    private kilonewtonmillimetersperdegreeLazy;
    private meganewtonmillimetersperdegreeLazy;
    private nanonewtonmetersperdegreeLazy;
    private micronewtonmetersperdegreeLazy;
    private millinewtonmetersperdegreeLazy;
    private centinewtonmetersperdegreeLazy;
    private decinewtonmetersperdegreeLazy;
    private decanewtonmetersperdegreeLazy;
    private kilonewtonmetersperdegreeLazy;
    private meganewtonmetersperdegreeLazy;
    private nanonewtonmillimetersperradianLazy;
    private micronewtonmillimetersperradianLazy;
    private millinewtonmillimetersperradianLazy;
    private centinewtonmillimetersperradianLazy;
    private decinewtonmillimetersperradianLazy;
    private decanewtonmillimetersperradianLazy;
    private kilonewtonmillimetersperradianLazy;
    private meganewtonmillimetersperradianLazy;
    /**
     * Create a new RotationalStiffness.
     * @param value The value.
     * @param fromUnit The ‘RotationalStiffness’ unit to create from.
     * The default unit is NewtonMetersPerRadian
     */
    constructor(value: number, fromUnit?: RotationalStiffnessUnits);
    /**
     * The base value of RotationalStiffness is NewtonMetersPerRadian.
     * This accessor used when needs a value for calculations and it's better to use directly the base value
     */
    get BaseValue(): number;
    /** Gets the default unit used when creating instances of the unit or its DTO */
    protected get baseUnit(): RotationalStiffnessUnits.NewtonMetersPerRadian;
    /** */
    get NewtonMetersPerRadian(): number;
    /** */
    get PoundForceFeetPerDegrees(): number;
    /** */
    get KilopoundForceFeetPerDegrees(): number;
    /** */
    get NewtonMillimetersPerDegree(): number;
    /** */
    get NewtonMetersPerDegree(): number;
    /** */
    get NewtonMillimetersPerRadian(): number;
    /** */
    get PoundForceFeetPerRadian(): number;
    /** */
    get KilonewtonMetersPerRadian(): number;
    /** */
    get MeganewtonMetersPerRadian(): number;
    /** */
    get NanonewtonMillimetersPerDegree(): number;
    /** */
    get MicronewtonMillimetersPerDegree(): number;
    /** */
    get MillinewtonMillimetersPerDegree(): number;
    /** */
    get CentinewtonMillimetersPerDegree(): number;
    /** */
    get DecinewtonMillimetersPerDegree(): number;
    /** */
    get DecanewtonMillimetersPerDegree(): number;
    /** */
    get KilonewtonMillimetersPerDegree(): number;
    /** */
    get MeganewtonMillimetersPerDegree(): number;
    /** */
    get NanonewtonMetersPerDegree(): number;
    /** */
    get MicronewtonMetersPerDegree(): number;
    /** */
    get MillinewtonMetersPerDegree(): number;
    /** */
    get CentinewtonMetersPerDegree(): number;
    /** */
    get DecinewtonMetersPerDegree(): number;
    /** */
    get DecanewtonMetersPerDegree(): number;
    /** */
    get KilonewtonMetersPerDegree(): number;
    /** */
    get MeganewtonMetersPerDegree(): number;
    /** */
    get NanonewtonMillimetersPerRadian(): number;
    /** */
    get MicronewtonMillimetersPerRadian(): number;
    /** */
    get MillinewtonMillimetersPerRadian(): number;
    /** */
    get CentinewtonMillimetersPerRadian(): number;
    /** */
    get DecinewtonMillimetersPerRadian(): number;
    /** */
    get DecanewtonMillimetersPerRadian(): number;
    /** */
    get KilonewtonMillimetersPerRadian(): number;
    /** */
    get MeganewtonMillimetersPerRadian(): number;
    /**
     * Create a new RotationalStiffness instance from a NewtonMetersPerRadian
     *
     * @param value The unit as NewtonMetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromNewtonMetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a PoundForceFeetPerDegrees
     *
     * @param value The unit as PoundForceFeetPerDegrees to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromPoundForceFeetPerDegrees(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a KilopoundForceFeetPerDegrees
     *
     * @param value The unit as KilopoundForceFeetPerDegrees to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromKilopoundForceFeetPerDegrees(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a NewtonMillimetersPerDegree
     *
     * @param value The unit as NewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromNewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a NewtonMetersPerDegree
     *
     * @param value The unit as NewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromNewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a NewtonMillimetersPerRadian
     *
     * @param value The unit as NewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromNewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a PoundForceFeetPerRadian
     *
     * @param value The unit as PoundForceFeetPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromPoundForceFeetPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a KilonewtonMetersPerRadian
     *
     * @param value The unit as KilonewtonMetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromKilonewtonMetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MeganewtonMetersPerRadian
     *
     * @param value The unit as MeganewtonMetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMeganewtonMetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a NanonewtonMillimetersPerDegree
     *
     * @param value The unit as NanonewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromNanonewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MicronewtonMillimetersPerDegree
     *
     * @param value The unit as MicronewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMicronewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MillinewtonMillimetersPerDegree
     *
     * @param value The unit as MillinewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMillinewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a CentinewtonMillimetersPerDegree
     *
     * @param value The unit as CentinewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromCentinewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a DecinewtonMillimetersPerDegree
     *
     * @param value The unit as DecinewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromDecinewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a DecanewtonMillimetersPerDegree
     *
     * @param value The unit as DecanewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromDecanewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a KilonewtonMillimetersPerDegree
     *
     * @param value The unit as KilonewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromKilonewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MeganewtonMillimetersPerDegree
     *
     * @param value The unit as MeganewtonMillimetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMeganewtonMillimetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a NanonewtonMetersPerDegree
     *
     * @param value The unit as NanonewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromNanonewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MicronewtonMetersPerDegree
     *
     * @param value The unit as MicronewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMicronewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MillinewtonMetersPerDegree
     *
     * @param value The unit as MillinewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMillinewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a CentinewtonMetersPerDegree
     *
     * @param value The unit as CentinewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromCentinewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a DecinewtonMetersPerDegree
     *
     * @param value The unit as DecinewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromDecinewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a DecanewtonMetersPerDegree
     *
     * @param value The unit as DecanewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromDecanewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a KilonewtonMetersPerDegree
     *
     * @param value The unit as KilonewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromKilonewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MeganewtonMetersPerDegree
     *
     * @param value The unit as MeganewtonMetersPerDegree to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMeganewtonMetersPerDegree(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a NanonewtonMillimetersPerRadian
     *
     * @param value The unit as NanonewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromNanonewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MicronewtonMillimetersPerRadian
     *
     * @param value The unit as MicronewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMicronewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MillinewtonMillimetersPerRadian
     *
     * @param value The unit as MillinewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMillinewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a CentinewtonMillimetersPerRadian
     *
     * @param value The unit as CentinewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromCentinewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a DecinewtonMillimetersPerRadian
     *
     * @param value The unit as DecinewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromDecinewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a DecanewtonMillimetersPerRadian
     *
     * @param value The unit as DecanewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromDecanewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a KilonewtonMillimetersPerRadian
     *
     * @param value The unit as KilonewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromKilonewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Create a new RotationalStiffness instance from a MeganewtonMillimetersPerRadian
     *
     * @param value The unit as MeganewtonMillimetersPerRadian to create a new RotationalStiffness from.
     * @returns The new RotationalStiffness instance.
     */
    static FromMeganewtonMillimetersPerRadian(value: number): RotationalStiffness;
    /**
     * Gets the base unit enumeration associated with RotationalStiffness
     * @returns The unit enumeration that can be used to interact with this type
     */
    protected static getUnitEnum(): typeof RotationalStiffnessUnits;
    /**
     * Gets the default unit used when creating instances of the unit or its DTO
     * @returns The unit enumeration value used as a default parameter in constructor and DTO methods
     */
    protected static getBaseUnit(): RotationalStiffnessUnits.NewtonMetersPerRadian;
    /**
     * Create API DTO represent a RotationalStiffness unit.
     * @param holdInUnit The specific RotationalStiffness unit to be used in the unit representation at the DTO
     */
    toDto(holdInUnit?: RotationalStiffnessUnits): RotationalStiffnessDto;
    /**
     * Create a RotationalStiffness unit from an API DTO representation.
     * @param dtoRotationalStiffness The RotationalStiffness API DTO representation
     */
    static FromDto(dtoRotationalStiffness: RotationalStiffnessDto): RotationalStiffness;
    /**
     * Convert RotationalStiffness to a specific unit value.
     * @param toUnit The specific unit to convert to
     * @returns The value of the specific unit provided.
     */
    convert(toUnit: RotationalStiffnessUnits): number;
    private convertFromBase;
    private convertToBase;
    /**
     * Format the RotationalStiffness to string.
     * Note! the default format for RotationalStiffness is NewtonMetersPerRadian.
     * To specify the unit format set the 'unit' parameter.
     * @param unit The unit to format the RotationalStiffness.
     * @param options The ToString options, it also can be the number of fractional digits to keep that deprecated and moved to the options object. support in number will be dropped in the upcoming versions.
     * @returns The string format of the RotationalStiffness.
     */
    toString(unit?: RotationalStiffnessUnits, options?: number | ToStringOptions): string;
    /**
     * Get RotationalStiffness unit abbreviation.
     * Note! the default abbreviation for RotationalStiffness is NewtonMetersPerRadian.
     * To specify the unit abbreviation set the 'unitAbbreviation' parameter.
     * @param unitAbbreviation The unit abbreviation of the RotationalStiffness.
     * @returns The abbreviation string of RotationalStiffness.
     */
    getUnitAbbreviation(unitAbbreviation?: RotationalStiffnessUnits): string;
    /**
     * Check if the given RotationalStiffness are equals to the current RotationalStiffness.
     * @param rotationalStiffness The other RotationalStiffness.
     * @returns True if the given RotationalStiffness are equal to the current RotationalStiffness.
     */
    equals(rotationalStiffness: RotationalStiffness): boolean;
    /**
     * Compare the given RotationalStiffness against the current RotationalStiffness.
     * @param rotationalStiffness The other RotationalStiffness.
     * @returns 0 if they are equal, -1 if the current RotationalStiffness is less then other, 1 if the current RotationalStiffness is greater then other.
     */
    compareTo(rotationalStiffness: RotationalStiffness): number;
    /**
     * Add the given RotationalStiffness with the current RotationalStiffness.
     * @param rotationalStiffness The other RotationalStiffness.
     * @returns A new RotationalStiffness instance with the results.
     */
    add(rotationalStiffness: RotationalStiffness): RotationalStiffness;
    /**
     * Subtract the given RotationalStiffness with the current RotationalStiffness.
     * @param rotationalStiffness The other RotationalStiffness.
     * @returns A new RotationalStiffness instance with the results.
     */
    subtract(rotationalStiffness: RotationalStiffness): RotationalStiffness;
    /**
     * Multiply the given RotationalStiffness with the current RotationalStiffness.
     * @param rotationalStiffness The other RotationalStiffness.
     * @returns A new RotationalStiffness instance with the results.
     */
    multiply(rotationalStiffness: RotationalStiffness): RotationalStiffness;
    /**
     * Divide the given RotationalStiffness with the current RotationalStiffness.
     * @param rotationalStiffness The other RotationalStiffness.
     * @returns A new RotationalStiffness instance with the results.
     */
    divide(rotationalStiffness: RotationalStiffness): RotationalStiffness;
    /**
     * Modulo the given RotationalStiffness with the current RotationalStiffness.
     * @param rotationalStiffness The other RotationalStiffness.
     * @returns A new RotationalStiffness instance with the results.
     */
    modulo(rotationalStiffness: RotationalStiffness): RotationalStiffness;
    /**
     * Pow the given RotationalStiffness with the current RotationalStiffness.
     * @param rotationalStiffness The other RotationalStiffness.
     * @returns A new RotationalStiffness instance with the results.
     */
    pow(rotationalStiffness: RotationalStiffness): RotationalStiffness;
}
