import { BaseUnit, ToStringOptions } from "../base-unit";
/** API DTO represents a TorquePerLength */
export interface TorquePerLengthDto {
    /** The value of the TorquePerLength */
    value: number;
    /**  The specific unit that the TorquePerLength value is representing */
    unit: TorquePerLengthUnits;
}
/** TorquePerLengthUnits enumeration */
export declare enum TorquePerLengthUnits {
    /** */
    NewtonMillimetersPerMeter = "NewtonMillimeterPerMeter",
    /** */
    NewtonCentimetersPerMeter = "NewtonCentimeterPerMeter",
    /** */
    NewtonMetersPerMeter = "NewtonMeterPerMeter",
    /** */
    PoundForceInchesPerFoot = "PoundForceInchPerFoot",
    /** */
    PoundForceFeetPerFoot = "PoundForceFootPerFoot",
    /** */
    KilogramForceMillimetersPerMeter = "KilogramForceMillimeterPerMeter",
    /** */
    KilogramForceCentimetersPerMeter = "KilogramForceCentimeterPerMeter",
    /** */
    KilogramForceMetersPerMeter = "KilogramForceMeterPerMeter",
    /** */
    TonneForceMillimetersPerMeter = "TonneForceMillimeterPerMeter",
    /** */
    TonneForceCentimetersPerMeter = "TonneForceCentimeterPerMeter",
    /** */
    TonneForceMetersPerMeter = "TonneForceMeterPerMeter",
    /** */
    KilonewtonMillimetersPerMeter = "KilonewtonMillimeterPerMeter",
    /** */
    MeganewtonMillimetersPerMeter = "MeganewtonMillimeterPerMeter",
    /** */
    KilonewtonCentimetersPerMeter = "KilonewtonCentimeterPerMeter",
    /** */
    MeganewtonCentimetersPerMeter = "MeganewtonCentimeterPerMeter",
    /** */
    KilonewtonMetersPerMeter = "KilonewtonMeterPerMeter",
    /** */
    MeganewtonMetersPerMeter = "MeganewtonMeterPerMeter",
    /** */
    KilopoundForceInchesPerFoot = "KilopoundForceInchPerFoot",
    /** */
    MegapoundForceInchesPerFoot = "MegapoundForceInchPerFoot",
    /** */
    KilopoundForceFeetPerFoot = "KilopoundForceFootPerFoot",
    /** */
    MegapoundForceFeetPerFoot = "MegapoundForceFootPerFoot"
}
/** The magnitude of torque per unit length. */
export declare class TorquePerLength extends BaseUnit {
    protected value: number;
    private newtonmillimeterspermeterLazy;
    private newtoncentimeterspermeterLazy;
    private newtonmeterspermeterLazy;
    private poundforceinchesperfootLazy;
    private poundforcefeetperfootLazy;
    private kilogramforcemillimeterspermeterLazy;
    private kilogramforcecentimeterspermeterLazy;
    private kilogramforcemeterspermeterLazy;
    private tonneforcemillimeterspermeterLazy;
    private tonneforcecentimeterspermeterLazy;
    private tonneforcemeterspermeterLazy;
    private kilonewtonmillimeterspermeterLazy;
    private meganewtonmillimeterspermeterLazy;
    private kilonewtoncentimeterspermeterLazy;
    private meganewtoncentimeterspermeterLazy;
    private kilonewtonmeterspermeterLazy;
    private meganewtonmeterspermeterLazy;
    private kilopoundforceinchesperfootLazy;
    private megapoundforceinchesperfootLazy;
    private kilopoundforcefeetperfootLazy;
    private megapoundforcefeetperfootLazy;
    /**
     * Create a new TorquePerLength.
     * @param value The value.
     * @param fromUnit The ‘TorquePerLength’ unit to create from.
     * The default unit is NewtonMetersPerMeter
     */
    constructor(value: number, fromUnit?: TorquePerLengthUnits);
    /**
     * The base value of TorquePerLength is NewtonMetersPerMeter.
     * This accessor used when needs a value for calculations and it's better to use directly the base value
     */
    get BaseValue(): number;
    /** Gets the default unit used when creating instances of the unit or its DTO */
    protected get baseUnit(): TorquePerLengthUnits.NewtonMetersPerMeter;
    /** */
    get NewtonMillimetersPerMeter(): number;
    /** */
    get NewtonCentimetersPerMeter(): number;
    /** */
    get NewtonMetersPerMeter(): number;
    /** */
    get PoundForceInchesPerFoot(): number;
    /** */
    get PoundForceFeetPerFoot(): number;
    /** */
    get KilogramForceMillimetersPerMeter(): number;
    /** */
    get KilogramForceCentimetersPerMeter(): number;
    /** */
    get KilogramForceMetersPerMeter(): number;
    /** */
    get TonneForceMillimetersPerMeter(): number;
    /** */
    get TonneForceCentimetersPerMeter(): number;
    /** */
    get TonneForceMetersPerMeter(): number;
    /** */
    get KilonewtonMillimetersPerMeter(): number;
    /** */
    get MeganewtonMillimetersPerMeter(): number;
    /** */
    get KilonewtonCentimetersPerMeter(): number;
    /** */
    get MeganewtonCentimetersPerMeter(): number;
    /** */
    get KilonewtonMetersPerMeter(): number;
    /** */
    get MeganewtonMetersPerMeter(): number;
    /** */
    get KilopoundForceInchesPerFoot(): number;
    /** */
    get MegapoundForceInchesPerFoot(): number;
    /** */
    get KilopoundForceFeetPerFoot(): number;
    /** */
    get MegapoundForceFeetPerFoot(): number;
    /**
     * Create a new TorquePerLength instance from a NewtonMillimetersPerMeter
     *
     * @param value The unit as NewtonMillimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromNewtonMillimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a NewtonCentimetersPerMeter
     *
     * @param value The unit as NewtonCentimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromNewtonCentimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a NewtonMetersPerMeter
     *
     * @param value The unit as NewtonMetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromNewtonMetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a PoundForceInchesPerFoot
     *
     * @param value The unit as PoundForceInchesPerFoot to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromPoundForceInchesPerFoot(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a PoundForceFeetPerFoot
     *
     * @param value The unit as PoundForceFeetPerFoot to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromPoundForceFeetPerFoot(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a KilogramForceMillimetersPerMeter
     *
     * @param value The unit as KilogramForceMillimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromKilogramForceMillimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a KilogramForceCentimetersPerMeter
     *
     * @param value The unit as KilogramForceCentimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromKilogramForceCentimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a KilogramForceMetersPerMeter
     *
     * @param value The unit as KilogramForceMetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromKilogramForceMetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a TonneForceMillimetersPerMeter
     *
     * @param value The unit as TonneForceMillimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromTonneForceMillimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a TonneForceCentimetersPerMeter
     *
     * @param value The unit as TonneForceCentimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromTonneForceCentimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a TonneForceMetersPerMeter
     *
     * @param value The unit as TonneForceMetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromTonneForceMetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a KilonewtonMillimetersPerMeter
     *
     * @param value The unit as KilonewtonMillimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromKilonewtonMillimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a MeganewtonMillimetersPerMeter
     *
     * @param value The unit as MeganewtonMillimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromMeganewtonMillimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a KilonewtonCentimetersPerMeter
     *
     * @param value The unit as KilonewtonCentimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromKilonewtonCentimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a MeganewtonCentimetersPerMeter
     *
     * @param value The unit as MeganewtonCentimetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromMeganewtonCentimetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a KilonewtonMetersPerMeter
     *
     * @param value The unit as KilonewtonMetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromKilonewtonMetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a MeganewtonMetersPerMeter
     *
     * @param value The unit as MeganewtonMetersPerMeter to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromMeganewtonMetersPerMeter(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a KilopoundForceInchesPerFoot
     *
     * @param value The unit as KilopoundForceInchesPerFoot to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromKilopoundForceInchesPerFoot(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a MegapoundForceInchesPerFoot
     *
     * @param value The unit as MegapoundForceInchesPerFoot to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromMegapoundForceInchesPerFoot(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a KilopoundForceFeetPerFoot
     *
     * @param value The unit as KilopoundForceFeetPerFoot to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromKilopoundForceFeetPerFoot(value: number): TorquePerLength;
    /**
     * Create a new TorquePerLength instance from a MegapoundForceFeetPerFoot
     *
     * @param value The unit as MegapoundForceFeetPerFoot to create a new TorquePerLength from.
     * @returns The new TorquePerLength instance.
     */
    static FromMegapoundForceFeetPerFoot(value: number): TorquePerLength;
    /**
     * Gets the base unit enumeration associated with TorquePerLength
     * @returns The unit enumeration that can be used to interact with this type
     */
    protected static getUnitEnum(): typeof TorquePerLengthUnits;
    /**
     * Gets the default unit used when creating instances of the unit or its DTO
     * @returns The unit enumeration value used as a default parameter in constructor and DTO methods
     */
    protected static getBaseUnit(): TorquePerLengthUnits.NewtonMetersPerMeter;
    /**
     * Create API DTO represent a TorquePerLength unit.
     * @param holdInUnit The specific TorquePerLength unit to be used in the unit representation at the DTO
     */
    toDto(holdInUnit?: TorquePerLengthUnits): TorquePerLengthDto;
    /**
     * Create a TorquePerLength unit from an API DTO representation.
     * @param dtoTorquePerLength The TorquePerLength API DTO representation
     */
    static FromDto(dtoTorquePerLength: TorquePerLengthDto): TorquePerLength;
    /**
     * Convert TorquePerLength to a specific unit value.
     * @param toUnit The specific unit to convert to
     * @returns The value of the specific unit provided.
     */
    convert(toUnit: TorquePerLengthUnits): number;
    private convertFromBase;
    private convertToBase;
    /**
     * Format the TorquePerLength to string.
     * Note! the default format for TorquePerLength is NewtonMetersPerMeter.
     * To specify the unit format set the 'unit' parameter.
     * @param unit The unit to format the TorquePerLength.
     * @param options The ToString options, it also can be the number of fractional digits to keep that deprecated and moved to the options object. support in number will be dropped in the upcoming versions.
     * @returns The string format of the TorquePerLength.
     */
    toString(unit?: TorquePerLengthUnits, options?: number | ToStringOptions): string;
    /**
     * Get TorquePerLength unit abbreviation.
     * Note! the default abbreviation for TorquePerLength is NewtonMetersPerMeter.
     * To specify the unit abbreviation set the 'unitAbbreviation' parameter.
     * @param unitAbbreviation The unit abbreviation of the TorquePerLength.
     * @returns The abbreviation string of TorquePerLength.
     */
    getUnitAbbreviation(unitAbbreviation?: TorquePerLengthUnits): string;
    /**
     * Check if the given TorquePerLength are equals to the current TorquePerLength.
     * @param torquePerLength The other TorquePerLength.
     * @returns True if the given TorquePerLength are equal to the current TorquePerLength.
     */
    equals(torquePerLength: TorquePerLength): boolean;
    /**
     * Compare the given TorquePerLength against the current TorquePerLength.
     * @param torquePerLength The other TorquePerLength.
     * @returns 0 if they are equal, -1 if the current TorquePerLength is less then other, 1 if the current TorquePerLength is greater then other.
     */
    compareTo(torquePerLength: TorquePerLength): number;
    /**
     * Add the given TorquePerLength with the current TorquePerLength.
     * @param torquePerLength The other TorquePerLength.
     * @returns A new TorquePerLength instance with the results.
     */
    add(torquePerLength: TorquePerLength): TorquePerLength;
    /**
     * Subtract the given TorquePerLength with the current TorquePerLength.
     * @param torquePerLength The other TorquePerLength.
     * @returns A new TorquePerLength instance with the results.
     */
    subtract(torquePerLength: TorquePerLength): TorquePerLength;
    /**
     * Multiply the given TorquePerLength with the current TorquePerLength.
     * @param torquePerLength The other TorquePerLength.
     * @returns A new TorquePerLength instance with the results.
     */
    multiply(torquePerLength: TorquePerLength): TorquePerLength;
    /**
     * Divide the given TorquePerLength with the current TorquePerLength.
     * @param torquePerLength The other TorquePerLength.
     * @returns A new TorquePerLength instance with the results.
     */
    divide(torquePerLength: TorquePerLength): TorquePerLength;
    /**
     * Modulo the given TorquePerLength with the current TorquePerLength.
     * @param torquePerLength The other TorquePerLength.
     * @returns A new TorquePerLength instance with the results.
     */
    modulo(torquePerLength: TorquePerLength): TorquePerLength;
    /**
     * Pow the given TorquePerLength with the current TorquePerLength.
     * @param torquePerLength The other TorquePerLength.
     * @returns A new TorquePerLength instance with the results.
     */
    pow(torquePerLength: TorquePerLength): TorquePerLength;
}
