import { BaseUnit, ToStringOptions } from "../base-unit";
/** API DTO represents a VolumeFlow */
export interface VolumeFlowDto {
    /** The value of the VolumeFlow */
    value: number;
    /**  The specific unit that the VolumeFlow value is representing */
    unit: VolumeFlowUnits;
}
/** VolumeFlowUnits enumeration */
export declare enum VolumeFlowUnits {
    /** */
    CubicMetersPerSecond = "CubicMeterPerSecond",
    /** */
    CubicMetersPerMinute = "CubicMeterPerMinute",
    /** */
    CubicMetersPerHour = "CubicMeterPerHour",
    /** */
    CubicMetersPerDay = "CubicMeterPerDay",
    /** */
    CubicFeetPerSecond = "CubicFootPerSecond",
    /** */
    CubicFeetPerMinute = "CubicFootPerMinute",
    /** */
    CubicFeetPerHour = "CubicFootPerHour",
    /** */
    CubicYardsPerSecond = "CubicYardPerSecond",
    /** */
    CubicYardsPerMinute = "CubicYardPerMinute",
    /** */
    CubicYardsPerHour = "CubicYardPerHour",
    /** */
    CubicYardsPerDay = "CubicYardPerDay",
    /** */
    MillionUsGallonsPerDay = "MillionUsGallonPerDay",
    /** */
    UsGallonsPerDay = "UsGallonPerDay",
    /** */
    LitersPerSecond = "LiterPerSecond",
    /** */
    LitersPerMinute = "LiterPerMinute",
    /** */
    LitersPerHour = "LiterPerHour",
    /** */
    LitersPerDay = "LiterPerDay",
    /** */
    UsGallonsPerSecond = "UsGallonPerSecond",
    /** */
    UsGallonsPerMinute = "UsGallonPerMinute",
    /** */
    UkGallonsPerDay = "UkGallonPerDay",
    /** */
    UkGallonsPerHour = "UkGallonPerHour",
    /** */
    UkGallonsPerMinute = "UkGallonPerMinute",
    /** */
    UkGallonsPerSecond = "UkGallonPerSecond",
    /** */
    KilousGallonsPerMinute = "KilousGallonPerMinute",
    /** */
    UsGallonsPerHour = "UsGallonPerHour",
    /** */
    CubicDecimetersPerMinute = "CubicDecimeterPerMinute",
    /** */
    OilBarrelsPerDay = "OilBarrelPerDay",
    /** */
    OilBarrelsPerMinute = "OilBarrelPerMinute",
    /** */
    OilBarrelsPerHour = "OilBarrelPerHour",
    /** */
    OilBarrelsPerSecond = "OilBarrelPerSecond",
    /** */
    CubicMillimetersPerSecond = "CubicMillimeterPerSecond",
    /** */
    AcreFeetPerSecond = "AcreFootPerSecond",
    /** */
    AcreFeetPerMinute = "AcreFootPerMinute",
    /** */
    AcreFeetPerHour = "AcreFootPerHour",
    /** */
    AcreFeetPerDay = "AcreFootPerDay",
    /** */
    CubicCentimetersPerMinute = "CubicCentimeterPerMinute",
    /** */
    MegausGallonsPerDay = "MegausGallonPerDay",
    /** */
    NanolitersPerSecond = "NanoliterPerSecond",
    /** */
    MicrolitersPerSecond = "MicroliterPerSecond",
    /** */
    MillilitersPerSecond = "MilliliterPerSecond",
    /** */
    CentilitersPerSecond = "CentiliterPerSecond",
    /** */
    DecilitersPerSecond = "DeciliterPerSecond",
    /** */
    DecalitersPerSecond = "DecaliterPerSecond",
    /** */
    HectolitersPerSecond = "HectoliterPerSecond",
    /** */
    KilolitersPerSecond = "KiloliterPerSecond",
    /** */
    MegalitersPerSecond = "MegaliterPerSecond",
    /** */
    NanolitersPerMinute = "NanoliterPerMinute",
    /** */
    MicrolitersPerMinute = "MicroliterPerMinute",
    /** */
    MillilitersPerMinute = "MilliliterPerMinute",
    /** */
    CentilitersPerMinute = "CentiliterPerMinute",
    /** */
    DecilitersPerMinute = "DeciliterPerMinute",
    /** */
    DecalitersPerMinute = "DecaliterPerMinute",
    /** */
    HectolitersPerMinute = "HectoliterPerMinute",
    /** */
    KilolitersPerMinute = "KiloliterPerMinute",
    /** */
    MegalitersPerMinute = "MegaliterPerMinute",
    /** */
    NanolitersPerHour = "NanoliterPerHour",
    /** */
    MicrolitersPerHour = "MicroliterPerHour",
    /** */
    MillilitersPerHour = "MilliliterPerHour",
    /** */
    CentilitersPerHour = "CentiliterPerHour",
    /** */
    DecilitersPerHour = "DeciliterPerHour",
    /** */
    DecalitersPerHour = "DecaliterPerHour",
    /** */
    HectolitersPerHour = "HectoliterPerHour",
    /** */
    KilolitersPerHour = "KiloliterPerHour",
    /** */
    MegalitersPerHour = "MegaliterPerHour",
    /** */
    NanolitersPerDay = "NanoliterPerDay",
    /** */
    MicrolitersPerDay = "MicroliterPerDay",
    /** */
    MillilitersPerDay = "MilliliterPerDay",
    /** */
    CentilitersPerDay = "CentiliterPerDay",
    /** */
    DecilitersPerDay = "DeciliterPerDay",
    /** */
    DecalitersPerDay = "DecaliterPerDay",
    /** */
    HectolitersPerDay = "HectoliterPerDay",
    /** */
    KilolitersPerDay = "KiloliterPerDay",
    /** */
    MegalitersPerDay = "MegaliterPerDay",
    /** */
    MegaukGallonsPerDay = "MegaukGallonPerDay",
    /** */
    MegaukGallonsPerSecond = "MegaukGallonPerSecond"
}
/** In physics and engineering, in particular fluid dynamics and hydrometry, the volumetric flow rate, (also known as volume flow rate, rate of fluid flow or volume velocity) is the volume of fluid which passes through a given surface per unit time. The SI unit is m³/s (cubic meters per second). In US Customary Units and British Imperial Units, volumetric flow rate is often expressed as ft³/s (cubic feet per second). It is usually represented by the symbol Q. */
export declare class VolumeFlow extends BaseUnit {
    protected value: number;
    private cubicmeterspersecondLazy;
    private cubicmetersperminuteLazy;
    private cubicmetersperhourLazy;
    private cubicmetersperdayLazy;
    private cubicfeetpersecondLazy;
    private cubicfeetperminuteLazy;
    private cubicfeetperhourLazy;
    private cubicyardspersecondLazy;
    private cubicyardsperminuteLazy;
    private cubicyardsperhourLazy;
    private cubicyardsperdayLazy;
    private millionusgallonsperdayLazy;
    private usgallonsperdayLazy;
    private literspersecondLazy;
    private litersperminuteLazy;
    private litersperhourLazy;
    private litersperdayLazy;
    private usgallonspersecondLazy;
    private usgallonsperminuteLazy;
    private ukgallonsperdayLazy;
    private ukgallonsperhourLazy;
    private ukgallonsperminuteLazy;
    private ukgallonspersecondLazy;
    private kilousgallonsperminuteLazy;
    private usgallonsperhourLazy;
    private cubicdecimetersperminuteLazy;
    private oilbarrelsperdayLazy;
    private oilbarrelsperminuteLazy;
    private oilbarrelsperhourLazy;
    private oilbarrelspersecondLazy;
    private cubicmillimeterspersecondLazy;
    private acrefeetpersecondLazy;
    private acrefeetperminuteLazy;
    private acrefeetperhourLazy;
    private acrefeetperdayLazy;
    private cubiccentimetersperminuteLazy;
    private megausgallonsperdayLazy;
    private nanoliterspersecondLazy;
    private microliterspersecondLazy;
    private milliliterspersecondLazy;
    private centiliterspersecondLazy;
    private deciliterspersecondLazy;
    private decaliterspersecondLazy;
    private hectoliterspersecondLazy;
    private kiloliterspersecondLazy;
    private megaliterspersecondLazy;
    private nanolitersperminuteLazy;
    private microlitersperminuteLazy;
    private millilitersperminuteLazy;
    private centilitersperminuteLazy;
    private decilitersperminuteLazy;
    private decalitersperminuteLazy;
    private hectolitersperminuteLazy;
    private kilolitersperminuteLazy;
    private megalitersperminuteLazy;
    private nanolitersperhourLazy;
    private microlitersperhourLazy;
    private millilitersperhourLazy;
    private centilitersperhourLazy;
    private decilitersperhourLazy;
    private decalitersperhourLazy;
    private hectolitersperhourLazy;
    private kilolitersperhourLazy;
    private megalitersperhourLazy;
    private nanolitersperdayLazy;
    private microlitersperdayLazy;
    private millilitersperdayLazy;
    private centilitersperdayLazy;
    private decilitersperdayLazy;
    private decalitersperdayLazy;
    private hectolitersperdayLazy;
    private kilolitersperdayLazy;
    private megalitersperdayLazy;
    private megaukgallonsperdayLazy;
    private megaukgallonspersecondLazy;
    /**
     * Create a new VolumeFlow.
     * @param value The value.
     * @param fromUnit The ‘VolumeFlow’ unit to create from.
     * The default unit is CubicMetersPerSecond
     */
    constructor(value: number, fromUnit?: VolumeFlowUnits);
    /**
     * The base value of VolumeFlow is CubicMetersPerSecond.
     * This accessor used when needs a value for calculations and it's better to use directly the base value
     */
    get BaseValue(): number;
    /** Gets the default unit used when creating instances of the unit or its DTO */
    protected get baseUnit(): VolumeFlowUnits.CubicMetersPerSecond;
    /** */
    get CubicMetersPerSecond(): number;
    /** */
    get CubicMetersPerMinute(): number;
    /** */
    get CubicMetersPerHour(): number;
    /** */
    get CubicMetersPerDay(): number;
    /** */
    get CubicFeetPerSecond(): number;
    /** */
    get CubicFeetPerMinute(): number;
    /** */
    get CubicFeetPerHour(): number;
    /** */
    get CubicYardsPerSecond(): number;
    /** */
    get CubicYardsPerMinute(): number;
    /** */
    get CubicYardsPerHour(): number;
    /** */
    get CubicYardsPerDay(): number;
    /** */
    get MillionUsGallonsPerDay(): number;
    /** */
    get UsGallonsPerDay(): number;
    /** */
    get LitersPerSecond(): number;
    /** */
    get LitersPerMinute(): number;
    /** */
    get LitersPerHour(): number;
    /** */
    get LitersPerDay(): number;
    /** */
    get UsGallonsPerSecond(): number;
    /** */
    get UsGallonsPerMinute(): number;
    /** */
    get UkGallonsPerDay(): number;
    /** */
    get UkGallonsPerHour(): number;
    /** */
    get UkGallonsPerMinute(): number;
    /** */
    get UkGallonsPerSecond(): number;
    /** */
    get KilousGallonsPerMinute(): number;
    /** */
    get UsGallonsPerHour(): number;
    /** */
    get CubicDecimetersPerMinute(): number;
    /** */
    get OilBarrelsPerDay(): number;
    /** */
    get OilBarrelsPerMinute(): number;
    /** */
    get OilBarrelsPerHour(): number;
    /** */
    get OilBarrelsPerSecond(): number;
    /** */
    get CubicMillimetersPerSecond(): number;
    /** */
    get AcreFeetPerSecond(): number;
    /** */
    get AcreFeetPerMinute(): number;
    /** */
    get AcreFeetPerHour(): number;
    /** */
    get AcreFeetPerDay(): number;
    /** */
    get CubicCentimetersPerMinute(): number;
    /** */
    get MegausGallonsPerDay(): number;
    /** */
    get NanolitersPerSecond(): number;
    /** */
    get MicrolitersPerSecond(): number;
    /** */
    get MillilitersPerSecond(): number;
    /** */
    get CentilitersPerSecond(): number;
    /** */
    get DecilitersPerSecond(): number;
    /** */
    get DecalitersPerSecond(): number;
    /** */
    get HectolitersPerSecond(): number;
    /** */
    get KilolitersPerSecond(): number;
    /** */
    get MegalitersPerSecond(): number;
    /** */
    get NanolitersPerMinute(): number;
    /** */
    get MicrolitersPerMinute(): number;
    /** */
    get MillilitersPerMinute(): number;
    /** */
    get CentilitersPerMinute(): number;
    /** */
    get DecilitersPerMinute(): number;
    /** */
    get DecalitersPerMinute(): number;
    /** */
    get HectolitersPerMinute(): number;
    /** */
    get KilolitersPerMinute(): number;
    /** */
    get MegalitersPerMinute(): number;
    /** */
    get NanolitersPerHour(): number;
    /** */
    get MicrolitersPerHour(): number;
    /** */
    get MillilitersPerHour(): number;
    /** */
    get CentilitersPerHour(): number;
    /** */
    get DecilitersPerHour(): number;
    /** */
    get DecalitersPerHour(): number;
    /** */
    get HectolitersPerHour(): number;
    /** */
    get KilolitersPerHour(): number;
    /** */
    get MegalitersPerHour(): number;
    /** */
    get NanolitersPerDay(): number;
    /** */
    get MicrolitersPerDay(): number;
    /** */
    get MillilitersPerDay(): number;
    /** */
    get CentilitersPerDay(): number;
    /** */
    get DecilitersPerDay(): number;
    /** */
    get DecalitersPerDay(): number;
    /** */
    get HectolitersPerDay(): number;
    /** */
    get KilolitersPerDay(): number;
    /** */
    get MegalitersPerDay(): number;
    /** */
    get MegaukGallonsPerDay(): number;
    /** */
    get MegaukGallonsPerSecond(): number;
    /**
     * Create a new VolumeFlow instance from a CubicMetersPerSecond
     *
     * @param value The unit as CubicMetersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicMetersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicMetersPerMinute
     *
     * @param value The unit as CubicMetersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicMetersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicMetersPerHour
     *
     * @param value The unit as CubicMetersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicMetersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicMetersPerDay
     *
     * @param value The unit as CubicMetersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicMetersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicFeetPerSecond
     *
     * @param value The unit as CubicFeetPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicFeetPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicFeetPerMinute
     *
     * @param value The unit as CubicFeetPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicFeetPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicFeetPerHour
     *
     * @param value The unit as CubicFeetPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicFeetPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicYardsPerSecond
     *
     * @param value The unit as CubicYardsPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicYardsPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicYardsPerMinute
     *
     * @param value The unit as CubicYardsPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicYardsPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicYardsPerHour
     *
     * @param value The unit as CubicYardsPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicYardsPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicYardsPerDay
     *
     * @param value The unit as CubicYardsPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicYardsPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MillionUsGallonsPerDay
     *
     * @param value The unit as MillionUsGallonsPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMillionUsGallonsPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a UsGallonsPerDay
     *
     * @param value The unit as UsGallonsPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromUsGallonsPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a LitersPerSecond
     *
     * @param value The unit as LitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromLitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a LitersPerMinute
     *
     * @param value The unit as LitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromLitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a LitersPerHour
     *
     * @param value The unit as LitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromLitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a LitersPerDay
     *
     * @param value The unit as LitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromLitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a UsGallonsPerSecond
     *
     * @param value The unit as UsGallonsPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromUsGallonsPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a UsGallonsPerMinute
     *
     * @param value The unit as UsGallonsPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromUsGallonsPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a UkGallonsPerDay
     *
     * @param value The unit as UkGallonsPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromUkGallonsPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a UkGallonsPerHour
     *
     * @param value The unit as UkGallonsPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromUkGallonsPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a UkGallonsPerMinute
     *
     * @param value The unit as UkGallonsPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromUkGallonsPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a UkGallonsPerSecond
     *
     * @param value The unit as UkGallonsPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromUkGallonsPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a KilousGallonsPerMinute
     *
     * @param value The unit as KilousGallonsPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromKilousGallonsPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a UsGallonsPerHour
     *
     * @param value The unit as UsGallonsPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromUsGallonsPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicDecimetersPerMinute
     *
     * @param value The unit as CubicDecimetersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicDecimetersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a OilBarrelsPerDay
     *
     * @param value The unit as OilBarrelsPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromOilBarrelsPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a OilBarrelsPerMinute
     *
     * @param value The unit as OilBarrelsPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromOilBarrelsPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a OilBarrelsPerHour
     *
     * @param value The unit as OilBarrelsPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromOilBarrelsPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a OilBarrelsPerSecond
     *
     * @param value The unit as OilBarrelsPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromOilBarrelsPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicMillimetersPerSecond
     *
     * @param value The unit as CubicMillimetersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicMillimetersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a AcreFeetPerSecond
     *
     * @param value The unit as AcreFeetPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromAcreFeetPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a AcreFeetPerMinute
     *
     * @param value The unit as AcreFeetPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromAcreFeetPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a AcreFeetPerHour
     *
     * @param value The unit as AcreFeetPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromAcreFeetPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a AcreFeetPerDay
     *
     * @param value The unit as AcreFeetPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromAcreFeetPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CubicCentimetersPerMinute
     *
     * @param value The unit as CubicCentimetersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCubicCentimetersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MegausGallonsPerDay
     *
     * @param value The unit as MegausGallonsPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMegausGallonsPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a NanolitersPerSecond
     *
     * @param value The unit as NanolitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromNanolitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MicrolitersPerSecond
     *
     * @param value The unit as MicrolitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMicrolitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MillilitersPerSecond
     *
     * @param value The unit as MillilitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMillilitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CentilitersPerSecond
     *
     * @param value The unit as CentilitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCentilitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a DecilitersPerSecond
     *
     * @param value The unit as DecilitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromDecilitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a DecalitersPerSecond
     *
     * @param value The unit as DecalitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromDecalitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a HectolitersPerSecond
     *
     * @param value The unit as HectolitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromHectolitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a KilolitersPerSecond
     *
     * @param value The unit as KilolitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromKilolitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MegalitersPerSecond
     *
     * @param value The unit as MegalitersPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMegalitersPerSecond(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a NanolitersPerMinute
     *
     * @param value The unit as NanolitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromNanolitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MicrolitersPerMinute
     *
     * @param value The unit as MicrolitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMicrolitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MillilitersPerMinute
     *
     * @param value The unit as MillilitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMillilitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CentilitersPerMinute
     *
     * @param value The unit as CentilitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCentilitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a DecilitersPerMinute
     *
     * @param value The unit as DecilitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromDecilitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a DecalitersPerMinute
     *
     * @param value The unit as DecalitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromDecalitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a HectolitersPerMinute
     *
     * @param value The unit as HectolitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromHectolitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a KilolitersPerMinute
     *
     * @param value The unit as KilolitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromKilolitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MegalitersPerMinute
     *
     * @param value The unit as MegalitersPerMinute to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMegalitersPerMinute(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a NanolitersPerHour
     *
     * @param value The unit as NanolitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromNanolitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MicrolitersPerHour
     *
     * @param value The unit as MicrolitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMicrolitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MillilitersPerHour
     *
     * @param value The unit as MillilitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMillilitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CentilitersPerHour
     *
     * @param value The unit as CentilitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCentilitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a DecilitersPerHour
     *
     * @param value The unit as DecilitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromDecilitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a DecalitersPerHour
     *
     * @param value The unit as DecalitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromDecalitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a HectolitersPerHour
     *
     * @param value The unit as HectolitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromHectolitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a KilolitersPerHour
     *
     * @param value The unit as KilolitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromKilolitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MegalitersPerHour
     *
     * @param value The unit as MegalitersPerHour to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMegalitersPerHour(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a NanolitersPerDay
     *
     * @param value The unit as NanolitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromNanolitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MicrolitersPerDay
     *
     * @param value The unit as MicrolitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMicrolitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MillilitersPerDay
     *
     * @param value The unit as MillilitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMillilitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a CentilitersPerDay
     *
     * @param value The unit as CentilitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromCentilitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a DecilitersPerDay
     *
     * @param value The unit as DecilitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromDecilitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a DecalitersPerDay
     *
     * @param value The unit as DecalitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromDecalitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a HectolitersPerDay
     *
     * @param value The unit as HectolitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromHectolitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a KilolitersPerDay
     *
     * @param value The unit as KilolitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromKilolitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MegalitersPerDay
     *
     * @param value The unit as MegalitersPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMegalitersPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MegaukGallonsPerDay
     *
     * @param value The unit as MegaukGallonsPerDay to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMegaukGallonsPerDay(value: number): VolumeFlow;
    /**
     * Create a new VolumeFlow instance from a MegaukGallonsPerSecond
     *
     * @param value The unit as MegaukGallonsPerSecond to create a new VolumeFlow from.
     * @returns The new VolumeFlow instance.
     */
    static FromMegaukGallonsPerSecond(value: number): VolumeFlow;
    /**
     * Gets the base unit enumeration associated with VolumeFlow
     * @returns The unit enumeration that can be used to interact with this type
     */
    protected static getUnitEnum(): typeof VolumeFlowUnits;
    /**
     * Gets the default unit used when creating instances of the unit or its DTO
     * @returns The unit enumeration value used as a default parameter in constructor and DTO methods
     */
    protected static getBaseUnit(): VolumeFlowUnits.CubicMetersPerSecond;
    /**
     * Create API DTO represent a VolumeFlow unit.
     * @param holdInUnit The specific VolumeFlow unit to be used in the unit representation at the DTO
     */
    toDto(holdInUnit?: VolumeFlowUnits): VolumeFlowDto;
    /**
     * Create a VolumeFlow unit from an API DTO representation.
     * @param dtoVolumeFlow The VolumeFlow API DTO representation
     */
    static FromDto(dtoVolumeFlow: VolumeFlowDto): VolumeFlow;
    /**
     * Convert VolumeFlow to a specific unit value.
     * @param toUnit The specific unit to convert to
     * @returns The value of the specific unit provided.
     */
    convert(toUnit: VolumeFlowUnits): number;
    private convertFromBase;
    private convertToBase;
    /**
     * Format the VolumeFlow to string.
     * Note! the default format for VolumeFlow is CubicMetersPerSecond.
     * To specify the unit format set the 'unit' parameter.
     * @param unit The unit to format the VolumeFlow.
     * @param options The ToString options, it also can be the number of fractional digits to keep that deprecated and moved to the options object. support in number will be dropped in the upcoming versions.
     * @returns The string format of the VolumeFlow.
     */
    toString(unit?: VolumeFlowUnits, options?: number | ToStringOptions): string;
    /**
     * Get VolumeFlow unit abbreviation.
     * Note! the default abbreviation for VolumeFlow is CubicMetersPerSecond.
     * To specify the unit abbreviation set the 'unitAbbreviation' parameter.
     * @param unitAbbreviation The unit abbreviation of the VolumeFlow.
     * @returns The abbreviation string of VolumeFlow.
     */
    getUnitAbbreviation(unitAbbreviation?: VolumeFlowUnits): string;
    /**
     * Check if the given VolumeFlow are equals to the current VolumeFlow.
     * @param volumeFlow The other VolumeFlow.
     * @returns True if the given VolumeFlow are equal to the current VolumeFlow.
     */
    equals(volumeFlow: VolumeFlow): boolean;
    /**
     * Compare the given VolumeFlow against the current VolumeFlow.
     * @param volumeFlow The other VolumeFlow.
     * @returns 0 if they are equal, -1 if the current VolumeFlow is less then other, 1 if the current VolumeFlow is greater then other.
     */
    compareTo(volumeFlow: VolumeFlow): number;
    /**
     * Add the given VolumeFlow with the current VolumeFlow.
     * @param volumeFlow The other VolumeFlow.
     * @returns A new VolumeFlow instance with the results.
     */
    add(volumeFlow: VolumeFlow): VolumeFlow;
    /**
     * Subtract the given VolumeFlow with the current VolumeFlow.
     * @param volumeFlow The other VolumeFlow.
     * @returns A new VolumeFlow instance with the results.
     */
    subtract(volumeFlow: VolumeFlow): VolumeFlow;
    /**
     * Multiply the given VolumeFlow with the current VolumeFlow.
     * @param volumeFlow The other VolumeFlow.
     * @returns A new VolumeFlow instance with the results.
     */
    multiply(volumeFlow: VolumeFlow): VolumeFlow;
    /**
     * Divide the given VolumeFlow with the current VolumeFlow.
     * @param volumeFlow The other VolumeFlow.
     * @returns A new VolumeFlow instance with the results.
     */
    divide(volumeFlow: VolumeFlow): VolumeFlow;
    /**
     * Modulo the given VolumeFlow with the current VolumeFlow.
     * @param volumeFlow The other VolumeFlow.
     * @returns A new VolumeFlow instance with the results.
     */
    modulo(volumeFlow: VolumeFlow): VolumeFlow;
    /**
     * Pow the given VolumeFlow with the current VolumeFlow.
     * @param volumeFlow The other VolumeFlow.
     * @returns A new VolumeFlow instance with the results.
     */
    pow(volumeFlow: VolumeFlow): VolumeFlow;
}
